secret = audio_stream_load("secret.ogg") 				audio_stream_set_looping(secret, true)
bloopin = audio_stream_load("bloopin.ogg")        		audio_stream_set_looping(bloopin, true)
secret = audio_stream_load("secret.ogg") 				audio_stream_set_looping(secret, true)
jumper = audio_stream_load("jumper.ogg") 				audio_stream_set_looping(jumper, true)
choco = audio_stream_load("choco.ogg") 					audio_stream_set_looping(choco, true)


currentlyPlaying = nil
local fadeTimer = 0
local fadePeak = 0
local volume = 1

---@param a BassAudio
function stream_play(a)
	if currentlyPlaying then audio_stream_stop(currentlyPlaying) end
	audio_stream_play(a, true, 1)
	currentlyPlaying = a
	fadeTimer = 0
end
function stream_fade(time)
	fadePeak = time
	fadeTimer = time
end
function stream_set_volume(vol)
	volume = vol
end
function stream_stop_all()
	audio_stream_stop(secret)
	audio_stream_stop(bloopin)
	audio_stream_stop(jumper)
	audio_stream_stop(choco)

	currentlyPlaying = nil
end
hook_event(HOOK_UPDATE, function ()
	if fadeTimer > 0 then
		fadeTimer = fadeTimer - 1
		if fadeTimer == 0 then
			stream_stop_all()
		end
	end
	if currentlyPlaying then
		audio_stream_set_volume(currentlyPlaying, (is_game_paused() and 0.2 or (fadeTimer ~= 0 and fadeTimer/fadePeak or 1)) * volume)
	end
end)

gSamples = {
	audio_sample_load("bonebreak.ogg"),
	audio_sample_load("bigexplosion.ogg"),
	audio_sample_load("electricscream.ogg"),
	audio_sample_load("shock.ogg"),
	audio_sample_load("mariodeath.ogg"),
	audio_sample_load("agonywaluigi.ogg"),
	audio_sample_load("flames.ogg"),
	audio_sample_load("truck.ogg"),
	audio_sample_load("bonebreak.ogg"),
	audio_sample_load("thump2.ogg"),
	audio_sample_load("hurry.ogg"),
	audio_sample_load("punch.ogg"),
	audio_sample_load("goomba.ogg"),
	audio_sample_load("agonymario.ogg"),
	audio_sample_load("cooloff.ogg"),
	audio_sample_load("ribbit.ogg"),
	audio_sample_load("r2l_car.ogg"),
	audio_sample_load("river.ogg"),
	audio_sample_load("bonebreak.ogg"),
	audio_sample_load("agonytoad.ogg"),
	audio_sample_load("bonebreak.ogg"),
	audio_sample_load("rifle.ogg"),
	audio_sample_load("meteor.ogg"),
	audio_sample_load("spikes.ogg"),
	audio_sample_load("sawmill.ogg"),
	audio_sample_load("sawhit.ogg"),
	audio_sample_load("agonyluigi.ogg"),
	audio_sample_load("gunshot.ogg"),
	audio_sample_load("bulletsplat.ogg"),
	audio_sample_load("agonywario.ogg"),
	audio_sample_load("sawmill2.ogg"),
	audio_sample_load("bulletmiss.ogg"),
	audio_sample_load("hunter.ogg"),
	audio_sample_load("hunter2.ogg"),
	audio_sample_load("mkds.ogg"),
	audio_sample_load("tf2.ogg")
}

sBoneBreak = 1
sBigExplosion = 2
sElectricScream = 3
sShock = 4
sSplatter = 5
sAgonyWaluigi = 6
sFlames = 7
sTruck = 8
sSMWBonusEnd = 9
sThump = 10
sHurry = 11
sPunch = 12
sGoombaStomp = 13
sAgonyMario = 14
sCoolOff = 15
sRibbit = 16
sR2l_car = 17
sRiver = 18
sCrunch = 19
sToadburn = 20
sFart = 21
sRifle = 22
sMeteor = 23
sSpikes = 24
sSawmill = 25
sSawhit = 26
sAgonyLuigi = 27
sGunshot = 28
sBulletSplat = 29
sAgonyWario = 30
sSawmill2 = 31
sBulletMiss = 32
sHunter = 33
sHunter2 = 34
sBoombox = 35
sBoombox2 = 36


function local_play(id, pos, vol)
	audio_sample_play(gSamples[id], pos, (is_game_paused() and 0 or vol))
end
function network_play(id, pos, vol, i)
    local_play(id, pos, vol)
    network_send(true, {id = id, x = pos.x, y = pos.y, z = pos.z, vol = vol, i = network_global_index_from_local(i)})
end
function stop_all_samples()
	for _, audio in pairs(gSamples) do
		audio_sample_stop(audio)
	end
end

hook_event(HOOK_ON_PACKET_RECEIVE, function (data)
	if is_player_active(gMarioStates[network_local_index_from_global(data.i)]) ~= 0 then
		local_play(data.id, {x=data.x, y=data.y, z=data.z}, data.vol)
	end
end)