-- name: GORE / Frogger!
-- description: A meteor has ruined your home, and now you must clear your way through dangerous random obstacles to find a new pond! 
-- incompatible: gore


gGlobalSyncTable.roundResetTimer = 300 --10 seconds
set_override_fov(60)

hud_hide()

--[[
set_lighting_color(0,25)
set_lighting_color(1,25)
set_lighting_color(2,112)
set_lighting_dir(1,198)
]]

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- GBEHAVIORVALUES -- Fast switches to manipulate the game.

gLevelValues.fixCollisionBugs = true

--Turns off bubble death.
gServerSettings.bubbleDeath = false

--(BoB, THI, TTM) bowling balls faster
gBehaviorValues.BowlingBallTtmSpeed = 40
gBehaviorValues.BowlingBallThiSmallSpeed = 45
gBehaviorValues.BowlingBallThiSmallSpeed = 45


local savedCollisionBugStatus

-- Unlock JRB cannon
save_file_set_star_flags(get_current_save_file_num() - 1, COURSE_JRB, 0x80)

----helpers------

function is_lowest_active_player()
	return get_network_player_smallest_global().localIndex == 0
end

function ia(m)
	return m.playerIndex == 0
end
function lerp(a, b, t) return a * (1 - t) + b * t end

---@param x? any
---@param y? any
---@param z? any
---@return Vec3f
function vec3f(x, y, z) return {x=x or 0,y=y or 0,z=z or 0} end

function pt(m) return gPlayerSyncTable[m.playerIndex] end

function limit_angle(a) return (a + 0x8000) % 0x10000 - 0x8000 end

function OBJ_POS(o) return o.header.gfx.pos end

function testing(m)
	local s = gStateExtras[m.playerIndex]

	if (m.controller.buttonPressed & D_JPAD) ~= 0 then
		--warp_to_level(LEVEL_POND, 1, 0)
	end

	if (m.controller.buttonPressed & L_JPAD) ~= 0 then
		--spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, m.pos.x + 200, m.pos.y, m.pos.z, nil)
	end

	if (m.controller.buttonPressed & R_JPAD) ~= 0 then		
	end

	if (m.controller.buttonPressed & U_JPAD) ~= 0 then
	end
end

function spawn_sync_if_main(behaviorId, modelId, x, y, z, objSetupFunction, i)
	print("index:", i)
	print("attempt by "..get_network_player_smallest_global().name)
	print(get_network_player_smallest_global().localIndex + i)
	if get_network_player_smallest_global().localIndex + i == 0 then print("passed!") return spawn_sync_object(behaviorId, modelId, x, y, z, objSetupFunction) end
end


local function modsupport()
	for key,value in pairs(gActiveMods) do
		if (value.name == "Flood") then
			floodenabled = true
		end
	end
end

function get_centered_text_x(t, scale)
	return (djui_hud_get_screen_width() - djui_hud_measure_text(t) * scale) / 2
end

------Variables n' stuff------

LEVEL_FROGGER = level_register('level_frogger_entry', COURSE_NONE, 'Frogger', 'Frogger', 28000, 0x28, 0x28, 0x28)
LEVEL_POND = level_register('level_frogger_pond_entry', COURSE_NONE, 'The Pond', 'The Pond', 28000, 0x28, 0x28, 0x28)

E_MODEL_BLOOD_MIST = smlua_model_util_get_id("blood_mist_geo")
E_MODEL_BLOOD_SPLATTER = smlua_model_util_get_id("blood_splatter_geo")
E_MODEL_BLOOD_SPLATTER2 = smlua_model_util_get_id("blood_splatter2_geo")
E_MODEL_GIB = smlua_model_util_get_id("gib_geo")

--Frog Rewards
E_MODEL_BULLFROG = smlua_model_util_get_id("bullfrog_geo")


--POND/WAITING AREA
E_MODEL_METEOR = smlua_model_util_get_id("meteor_geo")
COL_METEOR = smlua_collision_util_get("meteor_collision")

--OBSTACLE TRAFFIC
E_MODEL_OBSTACLE_TRAFFIC = smlua_model_util_get_id("obstacle_traffic_geo")
COL_TRAFFIC = smlua_collision_util_get("obstacle_traffic_collision")
E_MODEL_RED_TRUCK = smlua_model_util_get_id("red_truck_geo")
E_MODEL_WHITE_TRUCK = smlua_model_util_get_id("white_truck_geo")
E_MODEL_DARK_TRUCK = smlua_model_util_get_id("dark_truck_geo")
E_MODEL_BLUE_TRUCK = smlua_model_util_get_id("blue_truck_geo")
E_MODEL_GOLD_TRUCK = smlua_model_util_get_id("gold_truck_geo")
E_MODEL_LIGHTBLUE_TRUCK = smlua_model_util_get_id("lightblue_truck_geo")

--OBSTACLE WATER/LOGS
E_MODEL_OBSTACLE_RIVER = smlua_model_util_get_id("obstacle_river_geo")
COL_RIVER = smlua_collision_util_get("obstacle_river_collision")
E_MODEL_WATER_PLANE = smlua_model_util_get_id("waterplane_geo")
E_MODEL_LOG = smlua_model_util_get_id("log_geo")
COL_LOG = smlua_collision_util_get("log_collision")

--OBSTACLE THWOMPS
E_MODEL_OBSTACLE_THWOMPS = smlua_model_util_get_id("obstacle_thwomps_geo")
COL_THWOMPS = smlua_collision_util_get("obstacle_thwomps_collision")

--OBSTACLE SAWMILL
E_MODEL_OBSTACLE_SAWMILL = smlua_model_util_get_id("obstacle_sawmill_geo")
COL_SAWMILL = smlua_collision_util_get("obstacle_sawmill_collision")
E_MODEL_SAW = smlua_model_util_get_id("saw_geo")
E_MODEL_BLOOD_SAW = smlua_model_util_get_id("bloodsaw_geo")
E_MODEL_SPIKE_BASE = smlua_model_util_get_id("spike_base_geo")
E_MODEL_SPIKE = smlua_model_util_get_id("spike_geo")

--OBSTACLE LOG BRIDGE
E_MODEL_OBSTACLE_LOG_BRIDGE = smlua_model_util_get_id("obstacle_logbridge_geo")
COL_LOGBRIDGE = smlua_collision_util_get("obstacle_logbridge_collision")
E_MODEL_FROG_DORRIE = smlua_model_util_get_id("frogger_dorrie_geo")

--OBSTACLE HUNTER
E_MODEL_OBSTACLE_HUNTER = smlua_model_util_get_id("obstacle_hunter_geo")
COL_HUNTER = smlua_collision_util_get("obstacle_hunter_collision")
E_MODEL_LASER = smlua_model_util_get_id("laser_geo")
E_MODEL_HUNTER = smlua_model_util_get_id("hunter_geo")
E_MODEL_BOOMBOX = smlua_model_util_get_id("boombox_geo")

--FINISH
E_MODEL_FINISH = smlua_model_util_get_id("finish_geo")
COL_FINISH = smlua_collision_util_get("finish_collision")

--POWERUPS AND UI
E_MODEL_POWERUP_SPEED = smlua_model_util_get_id("powerup_speed_geo")
E_MODEL_TRIPPED = smlua_model_util_get_id("tripped_geo")

gStateExtras = {}
for i = 0, MAX_PLAYERS-1 do
	gStateExtras[i] = {
		splatter = 1,
		flyingVel = 0,
		enablesplattimer = 0, --w
		splattimer = 0,
		jumpland = 0,
		disappear = 0,
		bigthrowenabled = 0, --w
		isdead = false,
		stomped = false,
		headless = false,
		bottomless = false,
		disableuntilnextwarp = false,
		objtimer = 0,
		splatterdeath = 0,
		gibAngle = 0,
		gibVel = 0,
		gibYvelModifier = 0,
		iseliminated = false,
		isFinished = false,
		isCounted = true,
		playerScore = 0,
		tempScore = 0,
		currRank = 1,
		hasPowerup = false,
		hasSpeed = false,
		powerupTimer = 0,
	}
end

local roundStart_prompt = true
local initiate_countdown = false
gGlobalSyncTable.roundActive = false
gGlobalSyncTable.inactiveCount = 0
local texEliminated = get_texture_info('eliminated')
local texFinished = get_texture_info('finished')
local texFrogIcon = get_texture_info('frog')
local allEliminated = false
local playerRank = {
	{ name = "Tadpole",  	entryScore =     0},
	{ name = "Froglet",  	entryScore =  1000, model = E_MODEL_BULLFROG   },
	{ name = "Bull Frog",	entryScore =  3000, model = E_MODEL_BULLFROG   },
	{ name = "King Frog",	entryScore =  6000, model = E_MODEL_BULLFROG   },
	{ name = "FrLegend", 	entryScore =  9000, model = E_MODEL_BULLFROG   },
	{ name = "FrTitan!", 	entryScore = 13000, model = E_MODEL_BULLFROG   },
	{ name = "FrDEITY!", 	entryScore = 16000, model = E_MODEL_BULLFROG,  color = { r = 255, g = 255, b = 255 } }
}

gGlobalSyncTable.timerMax  = 450
gGlobalSyncTable.timer = 0
gGlobalSyncTable.Roundtimer = 0

function hud()
	local s = gStateExtras[0]
	local m = gMarioStates[0]
	local np = gNetworkPlayers[0]

	local t

	local rankDown = playerRank[s.currRank-1]
	local rank = playerRank[s.currRank]
	local rankUp = playerRank[s.currRank+1]

	local c = rank.color

	djui_hud_set_resolution(RESOLUTION_DJUI)
	djui_hud_set_font(FONT_NORMAL) -- set these to what you want
	local screenHeight = djui_hud_get_screen_height()
	local screenWidth = djui_hud_get_screen_width()

	if rankUp then
		djui_hud_set_color(255, 255, 255, 255)
		t = 'Next Promotion:'
		djui_hud_print_text(t, get_centered_text_x(t, 1), screenHeight - 78, 1)
		t = ""..(rankUp.entryScore-s.playerScore)
		djui_hud_print_text(t, get_centered_text_x(t, 1), screenHeight - 48, 1)

		if s.playerScore >= rankUp.entryScore then
			s.currRank = s.currRank + 1
			-- rank up jingle ?
		end
	elseif rankDown then
		if s.playerScore < rank.entryScore then
			s.currRank = s.currRank - 1
			-- rank down jingle ?
		end
	end

	djui_hud_set_resolution(RESOLUTION_N64)
	--Round Status
	if s.isEliminated then
		djui_hud_render_texture(texEliminated, 186, 44, .1, .1)
	end

	if s.isFinished then
		djui_hud_render_texture(texFinished, 186, 44, .1, .1)
	end

	if m.action == ACT_DUCK_HUNTED then
		djui_hud_set_resolution(RESOLUTION_DJUI)
		djui_hud_set_color(0, 0, 0, 255)
		djui_hud_render_rect(0, 0, screenWidth, screenHeight)
		if m.actionTimer > 2 then
			djui_hud_set_resolution(RESOLUTION_N64)
			local pos = vec3f()
			djui_hud_world_pos_to_screen_pos(m.pos, pos)

			local z = m.marioObj.header.gfx.cameraToObject.z
			local w = math.abs(14800/z)
			local h = math.abs(32000/z)

			djui_hud_set_color(255, 255, 255, 255)
			djui_hud_render_rect(pos.x-w/2, pos.y-h, w, h)
		end
	end

	djui_hud_set_resolution(RESOLUTION_DJUI)

	if roundStart_prompt then
		local t = "Waiting for players or press Dpad+Up to start."
		djui_hud_print_text(t, get_centered_text_x(t, 1), 15, 1)
	end

	if gGlobalSyncTable.timer > 0 then
		local totalSeconds = math.ceil((gGlobalSyncTable.timer) / 30)
		local minutes = math.floor(totalSeconds / 60)
		local seconds = totalSeconds % 60
		--local timerString = string.format("%02d :%02d", minutes, seconds)
		local timerString = tostring(seconds)

		t = "Round starting in..." .. tostring(timerString)

		djui_hud_print_text(t, get_centered_text_x(t, 1), 15, 1)
	end

	if gGlobalSyncTable.Roundtimer > 0 then
		local totalSeconds = math.ceil((gGlobalSyncTable.Roundtimer) / 30)
		local minutes = math.floor(totalSeconds / 60)
		local seconds = totalSeconds % 60
		--local timerString = string.format("%02d :%02d", minutes, seconds)
		local timerString = tostring(seconds)

		t = "Round ending in..." .. tostring(timerString)

		djui_hud_print_text(t, get_centered_text_x(t, 1), 15, 1)

	end

    --REMAINING FROGS ICON DISPLAY
    if np.currLevelNum == LEVEL_FROGGER then
		--local remaining = network_player_connected_count() - gGlobalSyncTable.inactiveCount
        local padding = 8

		local active = 0
		for i = 0, (MAX_PLAYERS - 1) do
			local m = gMarioStates[i]
			if active_count(m) ~= 0 and not gPlayerSyncTable[i].done then
				active = active + 1
			end
		end


        local width = active * 32 + padding * (active-1)
        for i=0, active-1 do
            --local spacing = ((screenWidth/2) - 7) + offset
			local offset = (32 + padding) * i
            djui_hud_render_texture(texFrogIcon, (screenWidth - width) / 2 + offset, 50, .5, .5)
        end
    end
end

camera_set_romhack_override(RCO_NONE)
function update_camera()
	local l = gLakituState
	local m = gMarioStates[0]
	local np = gNetworkPlayers[0]
	local s = gStateExtras[0]

	if np.currLevelNum == LEVEL_FROGGER then
		if m.action == ACT_RAGDOLL then
			l.mode = CAMERA_MODE_NONE
			vec3f_copy(l.goalFocus, m.pos)
		else
			l.mode = CAMERA_MODE_NONE

			--SPECTATOR CAM
			if s.isEliminated or s.isFinished then
				local finish = obj_get_first_with_behavior_id(id_bhvObstacleFinish)
				if finish then m = nearest_mario_state_to_object(finish) end
			end
			-- vec3f_set(l.goalFocus, m.pos.x, m.pos.y/1.5 + 300, m.pos.z - 500)
			-- vec3f_set(l.goalPos, m.pos.x + 1000, 300 + 1000, m.pos.z + 500)
			vec3f_set(l.goalFocus, m.pos.x/1.2, m.pos.y/1.5 + 300, m.pos.z - 250)
			vec3f_set(l.goalPos, m.pos.x/1.2, 300 + 1000, m.pos.z + 1000)
		end
	end
end
hook_event(HOOK_UPDATE, update_camera)

hook_event(HOOK_ON_SET_CAMERA_MODE, function (c, mode, frames)
	if mode == CAMERA_MODE_WATER_SURFACE then return false end
end)

ACT_GONE = allocate_mario_action(ACT_GROUP_CUTSCENE|ACT_FLAG_STATIONARY|ACT_FLAG_INTANGIBLE|ACT_FLAG_INVULNERABLE)
function act_gone(m)
	local s = gStateExtras[m.playerIndex]
	s.isgold = false
    m.marioObj.header.gfx.node.flags = m.marioObj.header.gfx.node.flags & ~GRAPH_RENDER_ACTIVE
end
hook_mario_action(ACT_GONE, act_gone)

-----------------------------------------------------------------------------------------------------------------------------
---------------Powerup Functions--------------------------------------------------------------------------------------------

function powerups(m)
	local s = gStateExtras[0]
	if m.playerIndex ~= 0 then return end

	if s.hasSpeed then
		s.hasPowerup = true
		if s.powerupTimer < 300 then
			s.powerupTimer = s.powerupTimer + 1
		else
			s.hasSpeed = false
			s.hasPowerup = false
			s.powerupTimer = 0
		end
		
		if m.action == ACT_WALKING or m.action == ACT_LONG_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_DIVE then
			m.forwardVel = m.forwardVel + 2
		end
	
	end
end


-----------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
-------Level Building Functions--------

function SET_BEH_PARAMS(x) return function (o) o.oBehParams = x end end
function OBSTACLE_ID(x) return SET_BEH_PARAMS(x) end
--fix for extra length add 21899
function obstacle_traffic(offset) --Spawns roadway with 4 vehicle spawners. (two left to right, two right to left) -- obstacle #1
	spawn_sync_object(id_bhvObstacle, E_MODEL_OBSTACLE_TRAFFIC, 0, 548, 25175 - offset, OBSTACLE_ID(1))
	spawn_sync_object(id_bhvr2lTruckSpawner, E_MODEL_NONE, -3845, 100, 24655 - offset, nil)
	spawn_sync_object(id_bhvr2lTruckSpawner, E_MODEL_NONE, -3845, 100, 25614 - offset, nil)
	spawn_sync_object(id_bhvl2rTruckSpawner, E_MODEL_NONE, 4031, 100, 25143 - offset, nil)
	spawn_sync_object(id_bhvl2rTruckSpawner, E_MODEL_NONE, 3499, 100, 26102 - offset, nil)
end

function obstacle_river(offset) --Spawns river, waterplane spanwer, and log spawners.  -- obstacle #2
	spawn_sync_object(id_bhvObstacle, E_MODEL_OBSTACLE_RIVER, -1414, 430, 25718 - offset, OBSTACLE_ID(2))
	spawn_sync_object(id_bhvLogSpawner, E_MODEL_NONE, -4831, 100, 26263 - offset, SET_BEH_PARAMS(1))
	spawn_sync_object(id_bhvLogSpawner, E_MODEL_NONE, -4831, 100, 24763 - offset, SET_BEH_PARAMS(2))
	spawn_sync_object(id_bhvLogSpawner, E_MODEL_NONE, -4831, 100, 22913 - offset, SET_BEH_PARAMS(3))
	spawn_sync_object(id_bhvWaterPlaneSpawner, E_MODEL_NONE, -6231, 100, 24763 - offset, nil)
end

function obstacle_thwomps(offset) -- obstacle #3
	local thwompdistance = 475
	spawn_sync_object(id_bhvObstacle, E_MODEL_OBSTACLE_THWOMPS, 156, -107, 26695 - offset, OBSTACLE_ID(3))
	for i = 0, 15 do
		local m = gMarioStates[i]
		spawn_sync_object(id_bhvThwomp, E_MODEL_THWOMP, -4040 + thwompdistance, 0, 26695 - offset, function(th)
			th.oFaceAngleYaw = 0
			th.oMoveAngleYaw = th.oFaceAngleYaw
			th.oFaceAnglePitch = 0
			th.oMoveAnglePitch = th.oFaceAnglePitch
		end)
		thwompdistance = thwompdistance + 480
	end
end

function obstacle_roller(offset) -- obstacle #4
	local thwompdistance = 250
	spawn_sync_object(id_bhvObstacle, E_MODEL_OBSTACLE_THWOMPS, 156, -107, 26695 - offset, OBSTACLE_ID(4))
	for i = 0, 10 do
		spawn_sync_object(id_bhvSpindel, E_MODEL_SSL_SPINDEL, -3740 + thwompdistance, 200, 25495 - offset, function(spin)
			--spin.oFaceAngleYaw = 16384
			--spin.oMoveAngleYaw = spin.oFaceAngleYaw
		end)
		thwompdistance = thwompdistance + 700
	end
end

function obstacle_hunter(offset)
	spawn_sync_object(id_bhvObstacle, E_MODEL_OBSTACLE_HUNTER, 156, -121, 24513.5 - offset, OBSTACLE_ID(5))
	spawn_sync_object(id_bhvLaser, E_MODEL_LASER, -40, 930, 21934 - offset, nil)
	spawn_sync_object(id_bhvBoombox, E_MODEL_BOOMBOX, 0, 730, 21099 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvHunter, E_MODEL_HUNTER, 0, 900, 21799 - offset, SET_FACE_ANGLE_YAW(0))

	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, 2600, 0, 23024 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -300, 0, 23024 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -1300, 0, 23024 - offset, SET_FACE_ANGLE_YAW(0))

	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, 1800, 0, 25124 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -800, 0, 25124 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -3400, 0, 25124 - offset, SET_FACE_ANGLE_YAW(0))

	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -2000, 0, 24599 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, 0, 0, 24599 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, 2000, 0, 24599 - offset, SET_FACE_ANGLE_YAW(0))

	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, 3300, 0, 23499 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -3300, 0, 23499 - offset, SET_FACE_ANGLE_YAW(0))

	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, 600, 0, 26424 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -600, 0, 26424 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, 2100, 0, 26424 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -1600, 0, 26424 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, -3200, 0, 26424 - offset, SET_FACE_ANGLE_YAW(0))
	spawn_sync_object(id_bhvPushableMetalBox, E_MODEL_METAL_BOX, 3200, 0, 26424 - offset, SET_FACE_ANGLE_YAW(0))
end


function obstacle_sawmill(offset) -- obstacle #6
	spawn_sync_object(id_bhvObstacle, E_MODEL_OBSTACLE_SAWMILL, -60, -382, 25415 - offset, OBSTACLE_ID(6))
	--spawn_sync_object(id_bhvObstacle, E_MODEL_OBSTACLE_SAWMILL, -60, -382, 3596 - offset, SET_BEH_PARAMS(6))
	spawn_sync_object(id_bhvSaw, E_MODEL_SAW, 0, 0, 26399 - offset, SET_BEH_PARAMS(1))
	spawn_sync_object(id_bhvSaw, E_MODEL_SAW, 0, 0, 23354 - offset, SET_BEH_PARAMS(2))
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 1940, 1008, 24724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 2240, 1008, 24724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 2540, 1008, 24724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 2840, 1008, 24724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 3140, 1008, 24724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 3440, 1008, 24724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 3740, 1008, 24724 - offset, nil)

	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 1940, 1008, 25724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 2240, 1008, 25724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 2540, 1008, 25724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 2840, 1008, 25724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 3140, 1008, 25724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 3440, 1008, 25724 - offset, nil)
	spawn_sync_object(id_bhvSpikes, E_MODEL_SPIKE_BASE, 3740, 1008, 25724 - offset, nil)

	spawn_sync_object(id_bhvSpeedPowerUp, E_MODEL_POWERUP_SPEED, 2840, 970, 25124 - offset, nil)
end

function obstacle_log_bridge(offset)
	spawn_sync_object(id_bhvObstacle, E_MODEL_OBSTACLE_LOG_BRIDGE, -1390, 432, 25719 - offset, OBSTACLE_ID(7))
	spawn_sync_object(id_bhvWaterPlaneSpawner, E_MODEL_NONE, -6231, 100, 24763 - offset, nil)
	spawn_sync_object(id_bhvGreenDorrie, E_MODEL_FROG_DORRIE, -1600, -190, 23063 - offset, nil)
	spawn_sync_object(id_bhvFlamethrower, E_MODEL_RED_FLAME, -600, 500, 23104 - offset, function(ft)
		ft.oFaceAngleYaw = 16384
		ft.oMoveAngleYaw = 16384
	end)
end

function SET_FACE_ANGLE_YAW(x) return function (o) o.oFaceAngleYaw = x end end


function obstacle_finish(offset)
	spawn_sync_object(id_bhvObstacleFinish, E_MODEL_FINISH, 15, -107, 27308 - offset, nil)
end

--OBSTACLE RIVER AND LOGBRIDGE WERE 7555
local obstaclePool = {
	{ length = 6192, setup = obstacle_traffic,     model = E_MODEL_OBSTACLE_TRAFFIC,    col = COL_TRAFFIC,   }, -- traffic
	{ length = 7548, setup = obstacle_river,       model = E_MODEL_OBSTACLE_RIVER,      col = COL_RIVER,     }, -- river
	{ length = 3150, setup = obstacle_thwomps,     model = E_MODEL_OBSTACLE_THWOMPS,    col = COL_THWOMPS,   }, -- thwomps
	{ length = 3150, setup = obstacle_roller,      model = E_MODEL_OBSTACLE_THWOMPS,    col = COL_THWOMPS,   }, -- spindels
	{ length = 7500, setup = obstacle_hunter,      model = E_MODEL_OBSTACLE_HUNTER,     col = COL_HUNTER,    }, -- hunter, will shoot players
	{ length = 5750, setup = obstacle_sawmill,     model = E_MODEL_OBSTACLE_SAWMILL,    col = COL_SAWMILL,   }, -- sawmill
	{ length = 7552, setup = obstacle_log_bridge,  model = E_MODEL_OBSTACLE_LOG_BRIDGE, col = COL_LOGBRIDGE, }, -- river with log bridges
}

local obstaclesSpawned = false
function spawn_obstacles()
	local np = gNetworkPlayers[0]
	if network_is_server() and np.currAreaSyncValid and np.currLevelNum == LEVEL_FROGGER and not obstaclesSpawned then
		local zOffset = 0
		local bag = {1,2,3,4,5,6,7}
		local obstacles = {}
		while #bag > 2 do --There are 7 obstacles total. While bag > 2 means it will spawn 5 obstacles before spawning the finish. (5 is the most, unfortunately. Will run out of level room)
			local obstacleIdx = math.random(#bag)
			table.insert(obstacles, bag[obstacleIdx])
			table.remove(bag, obstacleIdx)
		end
		for _, i in ipairs(obstacles) do
			local obstacle = obstaclePool[i]
			obstacle.setup(zOffset)
			zOffset = zOffset + obstacle.length
		end

		obstacle_finish(zOffset)
		
		obstaclesSpawned = true
	end
end

-----Custom Behaviors-----

function bhv_custom_explosion(obj) -- replaces generic explosions with NUKES! (Bigger radius, bigger explosion, louder)
	local m = nearest_mario_state_to_object(obj)
	local_play(sBigExplosion, m.pos, 1)
	cur_obj_shake_screen(SHAKE_POS_LARGE)
	spawn_sync_if_main(id_bhvBowserBombExplosion, E_MODEL_BOWSER_FLAMES, obj.oPosX, obj.oPosY, obj.oPosZ, nil, 0)
	if dist_between_objects(obj, m.marioObj) <= 850 then
		m.squishTimer = 50
	end
end

function bhv_custom_thwomp(obj)
	local m = nearest_player_to_object(obj)
	local np = gNetworkPlayers[0]
	if np.currLevelNum ~= LEVEL_TTC then --TTC is excluded for flood as its nearly unbeatable. Giving the player mercy by turning it off in regular game mode too.	
		obj.oThwompRandomTimer = 0 --Instant falling

		if obj.oAction == 0 then --ARISE!!
			obj.oPosY = obj.oPosY + 15
			if obj.oTimer == math.random(5, 40) then
				obj.oAction = 1
			end
		end
		if obj.oAction == 3 then --EARTHQUAAAAKE
			--cur_obj_shake_screen(SHAKE_POS_SMALL)
			spawn_mist_particles()
		end
		if obj.oAction == 4 then --No more waiting to rise!
			obj.oAction = 0
		end
		if obj.oAction == 2 then --CRUSH THEM (randomly) FAST!!
			obj.oVelY = obj.oVelY - 52
			obj.oTimer = 0
		end
		
		if obj.oAction == 3 and obj.oTimer > 1 and lateral_dist_between_objects(m, obj) < 150 then
			obj.oAction = 4
		end

	end
end


-------ACT_FUNCTIONS------------

function squishblood(o) -- Creates instant pool of impact-blood under mario.
	spawn_sync_object(id_bhvSquishblood, E_MODEL_BLOOD_SPLATTER, o.oPosX, find_floor_height(o.oPosX, o.oPosY, o.oPosZ) + 2, o.oPosZ, nil)
	bloodmist(o)
end

function bloodmist(o) -- Creates instant pool of impact-blood under mario.
	spawn_non_sync_object(id_bhvBloodMist, E_MODEL_BLOOD_MIST, o.oPosX, o.oPosY, o.oPosZ, nil)
end

--Mario's neck snapping action.
ACT_NECKSNAP = allocate_mario_action(ACT_GROUP_AUTOMATIC|ACT_FLAG_INVULNERABLE|ACT_FLAG_STATIONARY)
function act_necksnap(m)
	local s = gStateExtras[m.playerIndex]
	--common_death_handler(m, MARIO_ANIM_SUFFOCATING, 86)
	smlua_anim_util_set_animation(m.marioObj, "MARIO_NECKSNAP")
	m.actionTimer = m.actionTimer + 1
	if m.actionTimer == 1 then
		local_play(sBoneBreak, m.pos, 1)
		set_camera_shake_from_hit(SHAKE_LARGE_DAMAGE)
	end
end
hook_mario_action(ACT_NECKSNAP, act_necksnap)


local particleTiming = {
	[75]=1,
	[82]=1,
	[90]=1,
	[95]=1,
	[100]=1,
	[105]=1,
	[108]=1,
	[114]=1,
	[118]=1,
	[121]=1,
	[124]=1,
	[127]=1,
	[130]=1,
	[132]=1,
	[134]=1,
	[136]=1,
	[138]=1
}


--Electricutes the F out of Mario
function act_shocked(m)
	local s = gStateExtras[m.playerIndex]
	s.isgold = false
	m.actionTimer = m.actionTimer + 1
	set_mario_animation(m, MARIO_ANIM_SHOCKED)
	if m.actionTimer % 2 == 0 then
		m.flags = m.flags | MARIO_METAL_SHOCK
	else
		m.flags = m.flags & ~(MARIO_METAL_SHOCK)
	end
	if m.actionTimer == 20 or m.actionTimer == 40 or m.actionTimer == 50 or m.actionTimer == 65 then
		m.particleFlags = PARTICLE_MIST_CIRCLE
	end
	if m.actionTimer >= 50 then
		m.marioBodyState.eyeState = MARIO_EYES_DEAD
	end
	if particleTiming[m.actionTimer] then
		m.particleFlags = PARTICLE_TRIANGLE|PARTICLE_MIST_CIRCLE
	end
	if m.actionTimer == 140 then
		m.particleFlags = PARTICLE_TRIANGLE
		m.squishTimer = 50
	end
end
hook_mario_action(ACT_SHOCKED, act_shocked)

--Mario is decapitated.
ACT_DECAPITATED = allocate_mario_action(ACT_GROUP_AUTOMATIC|ACT_FLAG_INVULNERABLE|ACT_FLAG_STATIONARY)

local headlessModel = {
[0]=E_MODEL_HEADLESS_MARIO,
	E_MODEL_HEADLESS_LUIGI,
	E_MODEL_HEADLESS_TOAD,
	E_MODEL_HEADLESS_WALUIGI,
	E_MODEL_HEADLESS_WARIO,
}

function splattertimer(m) --This timer is needed to prevent mario from immediately splatting again right after respawning. Adds some fluff to his death too.
	local s = gStateExtras[m.playerIndex]
	local np = gNetworkPlayers[0]
	if s.enablesplattimer == 1 then
		s.splattimer = s.splattimer + 1
	end
	if s.splattimer == 2 then
		--m.health = 120
		set_mario_action(m, ACT_GONE, 0) --Throws mario forward more to "sell" the fall damage big impact.
		
		if s.disappear == 1 then --No fall damage, so Mario got squished. No corpse. It's funnier this way. 
			set_mario_action(m, ACT_GONE, 78)
			if np.currLevelNum == LEVEL_FROGGER then
				s.isEliminated = true
			end
			network_play(sRibbit, m.pos, 1, m.playerIndex)
		else
			set_mario_action(m, ACT_GONE, 78)
			network_play(sRibbit, m.pos, 1, m.playerIndex)
		end
		s.splattimer = s.splattimer + 1
	end

	if (s.splattimer) == 14 then
		spawn_sync_if_main(id_bhvStaticObject, E_MODEL_BLOOD_SPLATTER2, m.pos.x, find_floor_height(m.pos.x, m.pos.y, m.pos.z) + 2, m.pos.z,
		function (obj)
			local z, normal = vec3f(), cur_obj_update_floor_height_and_get_floor().normal
			obj.oFaceAnglePitch = 16384-calculate_pitch(z, normal)
			--obj.oFaceAngleYaw = calculate_yaw(z, normal)
		end, 0)
	end

	if (s.splattimer) == 20 then
		if (s.disappear) == 0 then
			--set_mario_action(m, ACT_GONE, 0)
		else
			s.enablesplattimer = 0
			s.splatter = 1
			s.splattimer = 0
			s.disappear = 0
		end
	end
	if (s.splattimer) == 150 then
		s.enablesplattimer = 0
		s.splatter = 1
		s.splattimer = 0
		s.disappear = 0
	end
end

function convert_s16(num)
	local min = -32768
	local max = 32767
	while (num < min) do
		num = max + (num - min)
	end
	while (num > max) do
		num = min + (num - max)
	end
	return num
end

_G.ACT_RAGDOLL = allocate_mario_action(ACT_GROUP_CUTSCENE|ACT_FLAG_STATIONARY|ACT_FLAG_INTANGIBLE|ACT_FLAG_INVULNERABLE)
function act_ragdoll(m)
	--djui_chat_message_create(tostring(m.actionTimer))
	local stepResult = perform_air_step(m, 0)
	if stepResult == AIR_STEP_LANDED then
		m.squishTimer = 5
	elseif m.wall then
		network_play(sSplatter, m.pos, 1, m.playerIndex)
		bloodmist(m.marioObj)
		spawn_sync_object(id_bhvStaticObject, E_MODEL_BLOOD_SPLATTER, m.pos.x, m.pos.y, m.pos.z, function(o)
			local z, normal = vec3f(), m.wallNormal
			o.oFaceAnglePitch = 16384
			o.oFaceAngleYaw = calculate_yaw(z, normal)
			o.oFaceAngleRoll = 0
			o.oPosX = o.oPosX - (48 * sins(o.oFaceAngleYaw))
			o.oPosZ = o.oPosZ - (48 * coss(o.oFaceAngleYaw))
		end)
		for i = 0, 50 do
			local random = math.random()
			spawn_non_sync_object(id_bhvGib, E_MODEL_GIB, m.pos.x, m.pos.y, m.pos.z, function (gib)
				obj_scale(gib, random) end)
		end
		set_mario_action(m, ACT_GONE, 0)
		return set_mario_action(m, ACT_GONE, 0)
	end
	set_character_animation(m, CHAR_ANIM_AIRBORNE_ON_STOMACH)

	m.marioBodyState.eyeState = MARIO_EYES_DEAD

	if m.actionArg == 1 then
		local l = gLakituState
		l.posHSpeed, l.posVSpeed, l.focHSpeed, l.focVSpeed = 0, 0, 0, 0
	end

	vec3s_set(m.angleVel, 2000, 1000, 400)
	vec3s_add(m.faceAngle, m.angleVel)
	vec3s_copy(m.marioObj.header.gfx.angle, m.faceAngle)
end
hook_mario_action(ACT_RAGDOLL, act_ragdoll)

ACT_DUCK_HUNTED = allocate_mario_action(ACT_GROUP_AIRBORNE|ACT_FLAG_AIR|ACT_FLAG_INTANGIBLE|ACT_FLAG_INVULNERABLE)
function act_duck_hunted(m)
	if m.actionTimer > 5 then
		play_character_sound(m, CHAR_SOUND_WAAAOOOW)

		local randAngle = calculate_yaw(gLakituState.pos, m.pos) + math.random(-8192, 8191)
		local randVel = math.random(30)+40
		m.vel.x = sins(randAngle) * randVel
		m.vel.z = coss(randAngle) * randVel
		m.vel.y = math.random(30)+20
		gStateExtras[m.playerIndex].isEliminated = true

		local_play(sRifle, gLakituState.pos, 1)

		set_camera_pitch_shake(0x60, 0x20, 0x8000)
		set_camera_roll_shake(0x60, 0x20, 0x8000)
		set_fov_shake(0x100, 0x20, 0x8000) -- doesn't work ? (works without the fov override- see line 1646)
		for i = 0, 25 do
			local random = math.random()
			spawn_sync_object(id_bhvGib, E_MODEL_GIB, m.pos.x, m.pos.y, m.pos.z, function (gib)
				obj_scale(gib, random)
			end)
		end

		return set_mario_action(m, ACT_RAGDOLL, 1)
	end

	m.actionTimer = m.actionTimer + 1
end
hook_mario_action(ACT_DUCK_HUNTED, act_duck_hunted)

ACT_IMPALED = allocate_mario_action(ACT_FLAG_INVULNERABLE)
function act_impaled(m)
	local s = gStateExtras[0]
	s.isEliminated = true
    if (is_anim_at_end(m)) and m.actionState ~= 1 then
		
        set_character_animation(m, CHAR_ANIM_DROWNING_PART2)
        play_sound(SOUND_MARIO_DYING, m.marioObj.header.gfx.cameraToObject)
		network_play(sRibbit, m.pos, 1, m.playerIndex)
        m.actionState = 1
        m.vel.x = 0
        m.vel.y = 0
        m.vel.z = 0
        m.forwardVel = 0
    end
    if m.actionState == 1 then
        m.marioBodyState.eyeState = MARIO_EYES_DEAD
        m.pos.y = m.floorHeight + 110
        m.forwardVel = 0
        perform_air_step(m, 0)
        m.vel.x = 0
        m.vel.y = 0
        m.vel.z = 0
        m.forwardVel = 0
    end
end
hook_mario_action(ACT_IMPALED, act_impaled)

function act_drowning(m)
	if (is_anim_at_end(m)) and m.actionState ~= 1 then
		set_character_animation(m, CHAR_ANIM_DROWNING_PART2)
		play_character_sound(m, CHAR_SOUND_DROWNING)
		m.actionState = 1
		m.vel.x = 0
		m.vel.y = 0
		m.vel.z = 0
		m.forwardVel = 0
	end
	if m.actionState == 1 then
		m.marioBodyState.eyeState = MARIO_EYES_DEAD
		m.pos.y = m.pos.y + 1
		m.forwardVel = 0
		perform_water_step(m)
		m.vel.x = 0
		m.vel.y = 0
		m.vel.z = 0
		m.forwardVel = 0
	end
end
hook_mario_action(ACT_DROWNING, act_drowning)

function round_start()
	local m = gMarioStates[0]
	local np = gNetworkPlayers[0]
	local s = gStateExtras[0]

	if np.currLevelNum == LEVEL_POND and gGlobalSyncTable.timer < 280 and gGlobalSyncTable.timer > 90 then
		play_sound(SOUND_ENV_WATER, m.marioObj.header.gfx.cameraToObject)
	end

	if np.currLevelNum == LEVEL_POND and gGlobalSyncTable.timer == 240 then
		cur_obj_play_sound_1(SOUND_ENV_WATER_DRAIN)
	end

	if np.currLevelNum == LEVEL_POND and gGlobalSyncTable.timer == 300 then
		spawn_sync_if_main(id_bhvMeteor, E_MODEL_NONE, 0, 8500, 0, nil, 0)
		network_play(sMeteor, m.pos, 1, m.playerIndex)

		gGlobalSyncTable.timer = 299
	end

	if np.currLevelNum == LEVEL_POND and not gGlobalSyncTable.roundActive and network_player_connected_count() > 1 and not initiate_countdown then
		initiate_countdown = true
		gGlobalSyncTable.timer = 450
		roundStart_prompt = false
	else
		if np.currLevelNum == LEVEL_POND and not gGlobalSyncTable.roundActive then
			if network_player_connected_count() > 1 and not initiate_countdown then
				gGlobalSyncTable.timer = 450
			else
				if not roundStart_prompt and not initiate_countdown and np.currLevelNum ~= LEVEL_FROGGER then
					roundStart_prompt = true
				end

				if (m.controller.buttonPressed & U_JPAD) ~= 0 then
					initiate_countdown = true
					gGlobalSyncTable.timer = 450
					--gGlobalSyncTable.timer = 5
					roundStart_prompt = false
				end
			end

			if np.currLevelNum == LEVEL_POND and gGlobalSyncTable.timer == 2 then
				if network_is_server() then
					gGlobalSyncTable.timer = 0
					gGlobalSyncTable.roundActive = true
				end
				initiate_countdown = false
				warp_to_level(LEVEL_POND, 1, 0)
			end
		end
	end
end

function round_reset(m)
	local s = gStateExtras[m.playerIndex]
	local s0 = gStateExtras[0]
	local np = gNetworkPlayers[0]

	local active = 0

	local networkcount = network_player_connected_count()
	if networkcount == 1 then
		if s0.isEliminated or s0.isFinished then
			active = 0
		else
			active = 1
		end		
	else
		for i = 0, (MAX_PLAYERS - 1) do
			if active_count(gMarioStates[i]) ~= 0 and not gPlayerSyncTable[i].done then
				active = active + 1
			end
		end
	end


	--djui_chat_message_create(tostring(active))

	

	--if gGlobalSyncTable.roundActive and gGlobalSyncTable.inactiveCount == MAX_PLAYERS then
	if np.currLevelNum == LEVEL_FROGGER and gGlobalSyncTable.roundActive and active == 0 then
		if gGlobalSyncTable.Roundtimer > 150 or gGlobalSyncTable.Roundtimer == 0 then
			allEliminated = true
		end
	end

	if np.currLevelNum == LEVEL_FROGGER and allEliminated and gGlobalSyncTable.roundActive then
		if gGlobalSyncTable.Roundtimer > 150 or gGlobalSyncTable.Roundtimer == 0 then
			if network_is_server() then
				gGlobalSyncTable.Roundtimer = 150
			end
		end
	end	
	if allEliminated and gGlobalSyncTable.Roundtimer == 2 then
		warp_to_level(LEVEL_POND, 1, 0)

	end

end

function active_count(m)
	local np = gNetworkPlayers[m.playerIndex]
    if not np.connected then
        return 0
    end
    if np.currCourseNum ~= gNetworkPlayers[0].currCourseNum then
        return 0
    end
    if np.currActNum ~= gNetworkPlayers[0].currActNum then
        return 0
    end
    if np.currLevelNum ~= gNetworkPlayers[0].currLevelNum then
        return 0
    end
    if np.currAreaIndex ~= gNetworkPlayers[0].currAreaIndex then
        return 0
    end

	if m.action == ACT_DROWNING or m.action == ACT_GONE or m.action == ACT_IMPALED then
		if np.currLevelNum == LEVEL_FROGGER then
			gPlayerSyncTable[m.playerIndex].done = true
		end
	end

    return is_player_active(m)
end

function mario_update(m) -- ALL Mario_Update hooked commands.
	if is_player_active(m) == 0 then return end
	local np = gNetworkPlayers[0]
	local s = gStateExtras[m.playerIndex]

	if np.currLevelNum == LEVEL_FROGGER and m.marioObj.oTimer == 1600 and gGlobalSyncTable.Roundtimer == 0 then
		if network_is_server() then
			gGlobalSyncTable.Roundtimer = 1050
		end
		network_play(sHurry, m.pos, 1, m.playerIndex)
	end

	if np.currLevelNum == LEVEL_FROGGER and m.marioObj.oTimer == 2350 and network_is_server() then
		allEliminated = true
	end

	if np.currLevelNum == LEVEL_FROGGER and m.action == ACT_GONE and not s.isFinished then
		s.isEliminated = true
	end

    if np.currLevelNum == LEVEL_FROGGER and s.isEliminated then
        network_player_set_description(gNetworkPlayers[m.playerIndex], "Dead", 255, 0, 0, 255)
	elseif np.currLevelNum == LEVEL_FROGGER then
        network_player_set_description(gNetworkPlayers[m.playerIndex], "Alive", 0, 255, 0, 255)
	end

	--TIMERS!!!
	if gGlobalSyncTable.timer > 0 and network_is_server() and ia(m) then
		gGlobalSyncTable.timer = gGlobalSyncTable.timer - 1
	end

	if gGlobalSyncTable.Roundtimer > 0 and network_is_server() and ia(m) then
		gGlobalSyncTable.Roundtimer = gGlobalSyncTable.Roundtimer - 1
	end

	if network_is_server() and ia(m) then
		gGlobalSyncTable.TruckSpawnTimer = math.random(50,500)
		gGlobalSyncTable.TruckVel = math.random(120,240)
		gGlobalSyncTable.LogSpawnTimer = math.random(250)
		gGlobalSyncTable.LogSpawnTimer2 = math.random(250)
		gGlobalSyncTable.LogSpawnTimer3 = math.random(250)
	end

	if m.marioObj.oTimer == 1 then
		m.health = 2048
	end

	if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED and m.action ~= ACT_DROWNING and np.currLevelNum == LEVEL_FROGGER then
		s.isEliminated = true
		set_mario_action(m, ACT_DROWNING, 0)
		m.vel.x = 0
		m.vel.y = 0
		m.vel.z = 0
		m.forwardVel = 0
		network_play(sRibbit, m.pos, 1, m.playerIndex)

	end


	--Moves player to appropriate level if they are just joining
	if gGlobalSyncTable.roundActive and np.currLevelNum ~= LEVEL_FROGGER and m.marioObj.oTimer > 5 then
		warp_to_level(LEVEL_FROGGER, 1, 0)
	end
	if not gGlobalSyncTable.roundActive and np.currLevelNum ~= LEVEL_POND and m.marioObj.oTimer > 5 then
		warp_to_level(LEVEL_POND, 1, 0)
	end

	if np.currLevelNum == LEVEL_POND and m.marioObj.oTimer < 5 then
		if network_is_server() then
			gGlobalSyncTable.roundActive = false
		end
		gGlobalSyncTable.Roundtimer = 0
		s.isEliminated = false
		s.isCounted = false
		s.isFinished = false
		allEliminated = false
		gGlobalSyncTable.saw1bloody = false
		gGlobalSyncTable.saw2bloody = false
		for i = 0, (MAX_PLAYERS - 1) do
			gPlayerSyncTable[i].done = false
		end
	end

	--if not in Frogger map, teleport player to frogger map
	if np.currLevelNum == LEVEL_FROGGER and m.marioObj.oTimer == 1 then
		m.pos.x = 0
		m.pos.y = -7
		m.pos.z = 28924
	end

	if np.currLevelNum == LEVEL_POND and m.marioObj.oTimer == 1 then
		m.pos.x = 30
		m.pos.y = -970
		m.pos.z = -14
	end

	--Soft reset when leaving the main level
	if np.currLevelNum == LEVEL_POND then
		obstaclesSpawned = false
		s.isEliminated = false
		s.isCounted = false
		s.isFinished = false
		allEliminated = false
		gGlobalSyncTable.saw1bloody = false
		gGlobalSyncTable.saw2bloody = false
	end
	

	if s.gibAngle ~= 0 and m.pos.y > m.floorHeight then
		s.gibAngle = 0
	end

	if s.isEliminated then
		s.tempScore = 0
	end

	if m.pos.y > 1800 and m.action ~= ACT_DUCK_HUNTED and m.action ~= ACT_RAGDOLL then
		set_mario_action(m, ACT_DUCK_HUNTED, 0)
	end

	--Player Rank commands. Mostly for giving higher ranked players new frogsuit models that have crowns and goodies. 
	--This feature has been scrapped for the time being due to time constraints. Maybe it will happen in V2? Maybe there will be a V2? Time will tell ig :>
	--[[
	if s.currRank == 1 then
	elseif s.currRank == 2 then
		obj_set_model_extended(m.marioObj, E_MODEL_BULLFROG)
	elseif s.currRank == 3 then
		obj_set_model_extended(m.marioObj, E_MODEL_BULLFROG)
	elseif s.currRank == 4 then
		obj_set_model_extended(m.marioObj, E_MODEL_BULLFROG)
	elseif s.currRank == 5 then
		obj_set_model_extended(m.marioObj, E_MODEL_BULLFROG)
	elseif s.currRank == 6 then
		obj_set_model_extended(m.marioObj, E_MODEL_BULLFROG)
	elseif s.currRank == 7 then
		obj_set_model_extended(m.marioObj, E_MODEL_BULLFROG)
	end
	]]


----------------------------------------------------------------------------------------------------------------------------------
	--Stupid shell riding

	if m.action == ACT_RIDING_SHELL_GROUND or m.action == ACT_RIDING_SHELL_JUMP or m.action == ACT_RIDING_SHELL_FALL then
		set_mario_anim_with_accel(m, MARIO_ANIM_FIRST_PERSON, 0) --Funny standing
		--set_mario_anim_with_accel(m, MARIO_ANIM_HOLDING_BOWSER, 0) --Funny thicc dumper
		--set_mario_anim_with_accel(m, MARIO_ANIM_TWIRL, 0) --Funny tpose
	end
----------------------------------------------------------------------------------------------------------------------------------
	-- FLY FASTER!!
	if m.action == ACT_FLYING or m.action == ACT_SHOT_FROM_CANNON or m.action == ACT_THROWN_BACKWARD or m.action == ACT_THROWN_FORWARD then -- Makes flying gradually get FASTER!
		m.forwardVel = m.forwardVel + 0.3
		s.flyingVel = m.forwardVel --This is to store Mario's last flying speed to check for splat-ability. 
	end

----------------------------------------------------------------------------------------------------------------------------------
	-- BONKING DEATHS!!
	if m.action == ACT_BACKWARD_AIR_KB or m.action == ACT_FORWARD_AIR_KB and s.flyingVel > 60 then -- Enables Mario to wall-splat when air-bonking objects.
		if m.prevAction == ACT_FLYING or m.prevAction == ACT_SHOT_FROM_CANNON then
			--mario_blow_off_cap(m, 45)
			m.forwardVel = m.forwardVel - 30
			m.action = ACT_SOFT_BONK --Needed to stop the first 'if' from running twice.
			set_mario_action(m, ACT_GONE, 78)
			--m.health = 0xff
			set_camera_shake_from_hit(SHAKE_LARGE_DAMAGE)
			m.particleFlags = PARTICLE_MIST_CIRCLE
			local_play(sSplatter, m.pos, 1)
			spawn_sync_object(id_bhvStaticObject, E_MODEL_BLOOD_SPLATTER, m.pos.x, m.pos.y, m.pos.z, function(o)
				local z, normal = vec3f(), m.wall.normal
				local x, xnormal = vec3f(), m.wall.normal
				o.oFaceAnglePitch = 16384-calculate_pitch(x, xnormal)
				o.oFaceAngleYaw = calculate_yaw(z, normal)
				o.oFaceAngleRoll = obj_resolve_collisions_and_turn(o.oFaceAngleYaw, 0)
				o.oPosX = o.oPosX - (48 * sins(o.oFaceAngleYaw))
				o.oPosZ = o.oPosZ - (48 * coss(o.oFaceAngleYaw))
			end)
			for i = 0, 50 do
				local random = math.random()	
				spawn_non_sync_object(id_bhvGib, E_MODEL_GIB, m.pos.x, m.pos.y, m.pos.z, function (gib)
					obj_scale(gib, random)
				end)
				
			end
	    end
	end

	-- BONK DEATH DETECTION FOR HEAVEHO THROWS SPECIFICALLY (Really just for WDW)
	if (m.action == ACT_THROWN_BACKWARD) or (m.action == ACT_THROWN_FORWARD) and (s.flyingVel > 60) and np.currLevelNum == LEVEL_WDW then 
		local heaveho = obj_get_nearest_object_with_behavior_id(o, id_bhvHeaveHoThrowMario)
		if heaveho ~= nil and mario_is_within_rectangle(heaveho.oPosX - 100, heaveho.oPosX + 100, heaveho.oPosZ - 100, heaveho.oPosZ + 100) == 0 and m.wall ~= nil then
			m.forwardVel = m.forwardVel - 30
			m.action = ACT_SOFT_BONK --Needed to stop the first 'if' from running twice.
			set_mario_action(m, ACT_GONE, 78)
			set_camera_shake_from_hit(SHAKE_LARGE_DAMAGE)
			m.particleFlags = PARTICLE_MIST_CIRCLE
			local_play(sSplatter, m.pos, 1)
			spawn_sync_object(id_bhvStaticObject, E_MODEL_BLOOD_SPLATTER, m.pos.x, m.pos.y, m.pos.z, function(o)
				local z, normal = vec3f(), m.wall.normal
				local x, xnormal = vec3f(), m.wall.normal
				o.oFaceAnglePitch = 16384-calculate_pitch(x, xnormal)
				o.oFaceAngleYaw = calculate_yaw(z, normal)
				o.oFaceAngleRoll = obj_resolve_collisions_and_turn(o.oFaceAngleYaw, 0)
				o.oPosX = o.oPosX - (48 * sins(o.oFaceAngleYaw))
				o.oPosZ = o.oPosZ - (48 * coss(o.oFaceAngleYaw))
			end)
		end
	end

----------------------------------------------------------------------------------------------------------------------------------
	--SPLAT CHECK. CHECKS TO SEE IF MARIO IS HIGH ENOUGH TO SPLAT.
	--IF S.splatter is equal to 1, that means splattering is enabled and Mario CAN be splattered. (Doesn't mean he IS splattered) 
	--This gets set to '0' when Mario IS splattered. After the splatter timer is up, it sets s.splatter back to 1 to re-enable splattering. 
	
	--if (s.splatter) == 1 and m.health > 0xff and not (m.action == ACT_BBH_ENTER_SPIN or m.action == ACT_BBH_ENTER_JUMP) then
	if (s.splatter) == 1 and m.action ~= ACT_GONE then
		if m.peakHeight >= 750 and m.vel.y <= -55 then  --Checks if Mario takes fall damage
			s.jumpland = 1 --If fall damage, then 1
		else
			s.jumpland = 0 --No fall damage
		end

		if s.jumpland == 1 and m.squishTimer >= 1 then -- Checks if Mario is squished from fall damage. If so, his mangled corpse will stay on screen.
			network_play(sSplatter, m.pos, 1, m.playerIndex)
			s.splatterdeath = 1
			s.splatter = 0
		end
		if s.jumpland == 0 and m.squishTimer >= 1 then --Checks if Mario was squished from NON-FALL damage. Objects/enemies that squish Mario will smoosh his corpse to invisible. 
			network_play(sSplatter, m.pos, 1, m.playerIndex)
			s.splatterdeath = 1
			s.splatter = 0
			s.disappear = 1 -- No corpse mode.  
		end
	end
	if (s.splatterdeath) == 1 then
		m.particleFlags = PARTICLE_MIST_CIRCLE
		squishblood(m.marioObj)
		s.splatterdeath = 0
		s.enablesplattimer = 1
		s.bigthrowenabled = 0
	end
----------------------------------------------------------------------------------------------------------------------------------
	--Mario Disintegrates when on fire
	if m.action == ACT_BURNING_JUMP or m.action == ACT_BURNING_GROUND or m.action == ACT_BURNING_FALL then
		if m.usedObj then
			cur_obj_shake_screen(SHAKE_POS_SMALL)
			--set_camera_shake_from_hit(SHAKE_LARGE_DAMAGE)
			obj_scale(m.usedObj, 6)
			obj_copy_pos(m.usedObj, m.marioObj)
			m.usedObj.oGraphYOffset = 100
			m.marioObj.oMarioBurnTimer = 1
		end

		if (m.health <= 300) then
			m.squishTimer = 50
			audio_sample_stop(gSamples[sAgonyMario])
			audio_sample_stop(gSamples[sAgonyLuigi])
			audio_sample_stop(gSamples[sAgonyWario])
			audio_sample_stop(gSamples[sToadburn])
			audio_sample_stop(gSamples[sAgonyWaluigi]) --Stops Waluigi's super long scream
		end

        local touchingwater = m.pos.y <= m.waterLevel
        if touchingwater then
            spawn_mist_particles()
            spawn_mist_particles()
            spawn_mist_particles()
            spawn_mist_particles()
            spawn_mist_particles()
			network_play(sCoolOff, m.pos, 1, m.playerIndex)
			audio_sample_stop(gSamples[sAgonyMario])
			audio_sample_stop(gSamples[sToadburn])
			audio_sample_stop(gSamples[sAgonyLuigi])
			audio_sample_stop(gSamples[sAgonyWario])
			audio_sample_stop(gSamples[sAgonyWaluigi])
			if m.usedObj then
				obj_mark_for_deletion(m.usedObj)
			end
        end
	end
	if m.usedObj and obj_has_behavior_id(m.usedObj, id_bhvFlame) ~= 0 and m.health < 128 then
		obj_mark_for_deletion(m.usedObj)
	end

----------------------------------------------------------------------------------------------------------------------------------
    --Goomba stomping sound effect.
    if m.bounceSquishTimer > 0 and not s.stomped then
        local_play(sGoombaStomp, m.pos, 1)
        s.stomped = true
    elseif m.bounceSquishTimer == 0 then s.stomped = false end

----------------------------------------------------------------------------------------------------------------------------------
	--Enables King Bobombs RIDICULOUS cannon-arm mario launch.
	if (m.action == ACT_GRABBED) then
		s.bigthrowenabled = 1
	end
	if (s.bigthrowenabled) == 1 then
		m.forwardVel = 280 --Was 150
	end
	if (s.bigthrowenabled) == 1 and m.hurtCounter > 0 then --  m.flags & ACT_AIR_THROW_LAND ~= 0 and m.action == 132193  both didnt work!
		m.squishTimer = 30
		s.bigthrowenabled = 0
	end
	if m.action == ACT_THROWN_FORWARD then
		s.bigthrowenabled = 0
	end

----------------------------------------------------------------------------------------------------------------------------------
	--Switches snow landing to snow drowning
	if (m.action == ACT_HEAD_STUCK_IN_GROUND) or (m.action == ACT_BUTT_STUCK_IN_GROUND) or (m.action == ACT_FEET_STUCK_IN_GROUND) then
		m.particleFlags = PARTICLE_MIST_CIRCLE
		set_mario_action(m, ACT_GONE, 60)
		--m.health = 0xff
 	end

----------------------------------------------------------------------------------------------------------------------------------
	--Mario has his hat after every respawn. Makes for funny deaths when his hat flies off.
	save_file_clear_flags(SAVE_FLAG_CAP_ON_GROUND | SAVE_FLAG_CAP_ON_KLEPTO | SAVE_FLAG_CAP_ON_UKIKI | SAVE_FLAG_CAP_ON_MR_BLIZZARD)
	m.cap = m.cap & ~(SAVE_FLAG_CAP_ON_GROUND | SAVE_FLAG_CAP_ON_KLEPTO | SAVE_FLAG_CAP_ON_UKIKI | SAVE_FLAG_CAP_ON_MR_BLIZZARD)
----------------------------------------------------------------------------------------------------------------------------------
	--(Whomps Fortress) No more wood platform
	o = obj_get_nearest_object_with_behavior_id(o, id_bhvWfRotatingWoodenPlatform)
	if (o) ~= nil then
		if mario_is_within_rectangle(o.oPosX - 50, o.oPosX + 50, o.oPosZ - 50, o.oPosZ + 50) ~= 0 then
			o.oPosY = o.oPosY - 100
			obj_mark_for_deletion(o)
		end
	end
----------------------------------------------------------------------------------------------------------------------------------

end






function mariohitbyenemy(m) -- Default and generic 1-hit death commands.
	if (m.hurtCounter > 0) then
		local s = gStateExtras[m.playerIndex]

		-- Air Insta-Kill Mario (jumping into enemy like Chain Chomp. Mario's fault, not a chain chomp attack)
		---@params
		if (m.action == ACT_FORWARD_AIR_KB or m.action == ACT_BACKWARD_AIR_KB) then
			m.forwardVel = -500
			m.vel.y = 15
		end

		-- BIG fall insta-kill (Falling from REALLY high)
		if (m.action == ACT_HARD_BACKWARD_GROUND_KB) then
			m.squishTimer = 50
		end
		if (m.action == ACT_HARD_FORWARD_GROUND_KB) then
			m.squishTimer = 50
		end
	end
end

function before_mario_action(m, action)
	local s = gStateExtras[m.playerIndex]
	local np = gNetworkPlayers[0]

-------------------------------------------------------------------------------------------------------------------------------------------------
	--Disables LAVA RUN and replaces with death.
	if (action == ACT_BURNING_JUMP) then --removed (action == ACT_BURNING_JUMP) or (action == ACT_BURNING_FALL) since it would reset each jump
		network_play(sFlames, m.pos, 1, m.playerIndex)

		if (m.marioObj.oMarioBurnTimer == 0) then
			if (m.usedObj and obj_has_behavior_id(m.usedObj, id_bhvFlame) == 0) or not m.usedObj then
				m.usedObj = spawn_sync_object(id_bhvFlame, E_MODEL_RED_FLAME, m.pos.x, m.pos.y, m.pos.z, nil)
			end
			if m.character.type == CT_MARIO then
				network_play(sAgonyMario, m.pos, 1, m.playerIndex)
			elseif m.character.type == CT_LUIGI then
				network_play(sAgonyLuigi, m.pos, 1, m.playerIndex)
			elseif m.character.type == CT_TOAD then
				network_play(sToadburn, m.pos, 1, m.playerIndex)
			elseif m.character.type == CT_WARIO then
				network_play(sAgonyWario, m.pos, 1, m.playerIndex)
			elseif m.character.type == CT_WALUIGI then
				network_play(sAgonyWaluigi, m.pos, 1, m.playerIndex)
			end
		end
	end
-------------------------------------------------------------------------------------------------------------------------------------------------
	--Unhides Mario if his action is changed for any reason. 
	if m.action == ACT_GONE then
		m.marioObj.header.gfx.node.flags = m.marioObj.header.gfx.node.flags | GRAPH_RENDER_ACTIVE
	end
end

function action_start(m)
	if m.action == ACT_NECKSNAP then
		local s = gStateExtras[m.playerIndex]
		squishblood(m.marioObj)

	elseif m.action == ACT_SHOCKED then -- play shock sounds
		local s = gStateExtras[m.playerIndex]
		network_play(sElectricScream, m.pos, 1, m.playerIndex)
		network_play(sShock, m.pos, 1, m.playerIndex)
		m.particleFlags = PARTICLE_MIST_CIRCLE
	end
end

function mariodeath() -- If mario is dead, this will pause the counter to prevent false positive 2nd deaths, like getting neck snapped (death 1) and then falling into lava. (death 2) 
	--Will also reset other functions as well.
	local s = gStateExtras[0]
	s.isEliminated = true
	audio_sample_stop(gSamples[sAgonyMario]) --Stops Mario's super long scream
	audio_sample_stop(gSamples[sAgonyLuigi]) --Stops Luigi's super long scream
	audio_sample_stop(gSamples[sToadburn]) --Stops Toad's super long scream
	audio_sample_stop(gSamples[sAgonyWario]) --Stops Wario's super long scream
	audio_sample_stop(gSamples[sAgonyWaluigi]) --Stops Waluigi's super long scream
	s.bigthrowenabled = 0
	stream_fade(50) --Stops the Hazy Maze Cave custom music after death. Stops the ukiki minigame music if Mario falls to death. 
	if not s.isdead and not s.disableuntilnextwarp then
		s.isdead = true
	end
end

function marioalive() -- Resumes the death counter to accept death counts. 
	local s = gStateExtras[0]
	local np = gNetworkPlayers[0]
	local m = gMarioStates[0]
	audio_sample_stop(gSamples[sAgonyMario]) --Stops Mario's super long scream
	audio_sample_stop(gSamples[sToadburn]) --Stops Toad's super long scream
	audio_sample_stop(gSamples[sAgonyLuigi]) --Stops Luigi's super long scream
	audio_sample_stop(gSamples[sAgonyWario]) --Stops Wario's super long scream
	audio_sample_stop(gSamples[sAgonyWaluigi]) --Stops Waluigi's super long scream
	s.headless = false --Gives Mario his head back
	s.bottomless = false --Gives Mario his whole upper body back



	
end

---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function mario_before_phys_step(m)
	local hScale = 1.0
	local vScale = 1.0

	-- faster swimming
	if (m.action & ACT_FLAG_SWIMMING) ~= 0 then
		hScale = hScale * 5.0
		if m.action ~= ACT_WATER_PLUNGE then
			vScale = vScale * 5.0
		end
	end

	m.vel.x = m.vel.x * hScale
	m.vel.y = m.vel.y * vScale
	m.vel.z = m.vel.z * hScale
end



---------hooks--------
hook_event(HOOK_MARIO_UPDATE, powerups)
hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_MARIO_UPDATE, modsupport)
hook_event(HOOK_MARIO_UPDATE, testing)
hook_event(HOOK_MARIO_UPDATE, mariohitbyenemy)
hook_event(HOOK_MARIO_UPDATE, splattertimer)
hook_event(HOOK_ON_WARP, marioalive)
hook_event(HOOK_BEFORE_PHYS_STEP, mario_before_phys_step)
hook_event(HOOK_BEFORE_SET_MARIO_ACTION, before_mario_action)
hook_event(HOOK_ON_SET_MARIO_ACTION, action_start)
hook_event(HOOK_ON_DEATH, mariodeath)

-------------PvP HOOKS-------------

--Custom PvP
hook_event(HOOK_ON_PVP_ATTACK, function (attacker, victim)
	local np = gNetworkPlayers[0]
	local s = gStateExtras[victim.playerIndex]

	local actionExceptions = {
		[ACT_BACKWARD_GROUND_KB] = true,
		[ACT_FORWARD_GROUND_KB] = true,
		[ACT_FORWARD_AIR_KB] = true,
		[ACT_BACKWARD_AIR_KB] = true
	}

	--Enables 'ground pound' PvP splattering. 
	if attacker.action == ACT_GROUND_POUND and s.splatter == 1 and np.currLevelNum == LEVEL_POND then
		local_play(sSplatter, victim.pos, 1)
		s.splatterdeath = 1
		s.splatter = 0
		s.disappear = 1 -- No corpse mode.  
	end

	--Punching Sounds and blood
	if (attacker.action == ACT_PUNCHING) or (attacker.action == ACT_JUMP_KICK) or (attacker.action == ACT_MOVE_PUNCHING) then
		local_play(sPunch, victim.pos, 1)
		squishblood(victim.marioObj)
		if not actionExceptions[victim.action] then
			
		end
	end

	--Tripping
	if attacker.action == ACT_SLIDE_KICK and victim.action ~= ACT_HARD_BACKWARD_GROUND_KB then
		set_mario_action(victim, ACT_HARD_BACKWARD_GROUND_KB, 0)
		spawn_sync_if_main(id_bhvTripped, E_MODEL_TRIPPED, victim.pos.x, victim.pos.y + 80, victim.pos.z, nil, 0)
		s.tempScore = s.tempScore + 100
	end

	--[[
	--Neck snapping
	if attacker.action == ACT_DIVE and victim.action ~= ACT_NECKSNAP then
		--local_play(sBoneBreak, victim.pos, 1)
		set_mario_action(victim, ACT_NECKSNAP, 0)
		set_mario_action(attacker, ACT_DIVE_SLIDE, 0)
	end
	]]

end)


---@param o Object
---@return Vec3f
function get_pressure_point(o)
	local avg = vec3f()
	local obj = vec3f()
	object_pos_to_vec3f(obj, o)
	local count = 0
	for i = 0, MAX_PLAYERS-1 do
		local m = gMarioStates[i]
		if is_player_active(m) ~= 0 and m.marioObj and m.marioObj.platform == o then
			vec3f_add(avg, m.pos)
			count = count + 1
		end
	end
	if count < 1 then return vec3f() end
	vec3f_mul(avg, 1/count)
	vec3f_sub(avg, obj)
	return avg
end

function squishblood_init(o)
	local m = gMarioStates[0]
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true	
	local z, normal = vec3f(), cur_obj_update_floor_height_and_get_floor().normal
	o.oFaceAnglePitch = 16384-calculate_pitch(z, normal)
	o.oFaceAngleYaw = calculate_yaw(z, normal)
	o.oFaceAngleRoll = 0
	for i = 0, 60 do
		local random = math.random()		
		spawn_non_sync_object(id_bhvGib, E_MODEL_GIB, o.oPosX, o.oPosY, o.oPosZ, function (gib)
			obj_scale(gib, random/2)
		end)
	end
end

function squishblood_loop(o)
	cur_obj_update_floor()
	local z, normal = vec3f(), cur_obj_update_floor_height_and_get_floor().normal
	o.oFaceAnglePitch = 16384-calculate_pitch(z, normal)
	o.oFaceAngleYaw = calculate_yaw(z, normal)
	o.oFaceAngleRoll = 0
	if o.oPosY ~= o.oFloorHeight + 2 then
		o.oPosY = o.oFloorHeight + 2
	end
	if o.oFloor.type == SURFACE_DEATH_PLANE then
		obj_mark_for_deletion(o)
	end
end

function blood_mist_init(o)
	-- someone more experienced than me can probably do the init and loop better
	--local s = gStateExtras[0]
    o.oFlags = (OBJ_FLAG_ACTIVE_FROM_AFAR | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
	o.header.gfx.node.flags = o.header.gfx.node.flags | GRAPH_RENDER_BILLBOARD
	o.header.gfx.skipInViewCheck = true
	o.oGraphYOffset = 40
	
	obj_scale(o, 1)
end

function blood_mist_loop(o)
	o.oOpacity = (-clampf(math.floor(o.oTimer * 8), 0, 255) + 255)
	o.oGraphYOffset = o.oGraphYOffset + -2.5

	if o.oTimer > 30 then -- 2 second timer before deleting. 
		obj_mark_for_deletion(o)
	end
end

function gib_init(o)
	local s = gStateExtras[0]
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	local randomfvel = math.random(1,20) --Perhaps we can partially add Mario's velocity into this equation?
	local random = math.random(20,50)
	local randomyaw = math.random(1,65536)
	local directionalVelRand = math.random(-3000,3000)
	o.oBounciness = 0
	o.oGravity = -4
	o.oVelY = random + s.gibYvelModifier
	o.oForwardVel = randomfvel + s.gibVel
	if s.gibAngle ~= 0 then
		o.oFaceAngleYaw = s.gibAngle + directionalVelRand
	else
		o.oFaceAngleYaw = randomyaw
	end
	o.oMoveAngleYaw = o.oFaceAngleYaw
	o.oPosY = o.oPosY + 10 --This gets the gibs off the floor, allowing the loop code to run.
	cur_obj_update_floor_height_and_get_floor()

end

function gib_loop(o)
	local s = gStateExtras[0]
	--load_object_collision_model()
	--m = gMarioStates[0]
	local random = math.random(1,1500)
	--djui_chat_message_create(tostring(o.oFloorHeight))
	cur_obj_update_floor_height_and_get_floor()

	if o.oPosY > o.oFloorHeight then
		cur_obj_move_using_fvel_and_gravity()
		cur_obj_move_using_vel()
		cur_obj_update_floor_height_and_get_floor()
		o.oFaceAnglePitch = o.oFaceAnglePitch + random
		o.oFaceAngleRoll = o.oFaceAngleRoll + random
		o.oFaceAngleYaw = o.oFaceAngleYaw + random

	else
		o.oPosY = o.oFloorHeight
		s.gibAngle = 0
	end

	if o.oTimer > 1200 then -- 40 second timer before deleting. 
		obj_mark_for_deletion(o)
	end
end

function l2r_truck_spawner(o)
	local truckcount = obj_count_objects_with_behavior_id(id_bhvTruck)
	if o.oTimer % 30 then
		gGlobalSyncTable.TruckSpawnTimer = math.random(50,500)
	end
	if truckcount < 8 and o.oTimer > gGlobalSyncTable.TruckSpawnTimer then
		local color = math.random(1,6)
		if color == 1 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_RED_TRUCK, -4300, -7, o.oPosZ, nil, 0)
		elseif color == 2 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_WHITE_TRUCK, -4300, -7, o.oPosZ, nil, 0)
		elseif color == 3 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_DARK_TRUCK, -4300, -7, o.oPosZ, nil, 0)
		elseif color == 4 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_BLUE_TRUCK, -4300, -7, o.oPosZ, nil, 0)
		elseif color == 5 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_GOLD_TRUCK, -4300, -7, o.oPosZ, nil, 0)
		elseif color == 6 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_LIGHTBLUE_TRUCK, -4300, -7, o.oPosZ, nil, 0)
		end
		o.oTimer = 0
	end
end

function r2l_truck_spawner(o)
	local truckcount = obj_count_objects_with_behavior_id(id_bhvTruck)
	if o.oTimer % 30 then
		gGlobalSyncTable.TruckSpawnTimer = math.random(50,500)
	end
	if truckcount < 8 and o.oTimer > gGlobalSyncTable.TruckSpawnTimer then
		local color = math.random(1,6)
		if color == 1 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_RED_TRUCK, 4000, -7, o.oPosZ, function(truck) truck.oBehParams = 1 end, 0)
		elseif color == 2 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_WHITE_TRUCK, 4000, -7, o.oPosZ, function(truck)truck.oBehParams = 1 end, 0)
		elseif color == 3 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_DARK_TRUCK, 4000, -7, o.oPosZ, function(truck)truck.oBehParams = 1 end, 0)
		elseif color == 4 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_BLUE_TRUCK, 4000, -7, o.oPosZ, function(truck)truck.oBehParams = 1 end, 0)
		elseif color == 5 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_GOLD_TRUCK, 4000, -7, o.oPosZ, function(truck)truck.oBehParams = 1 end, 0)
		elseif color == 6 then
			spawn_sync_if_main(id_bhvTruck, E_MODEL_LIGHTBLUE_TRUCK, 4000, -7, o.oPosZ, function(truck)truck.oBehParams = 1 end, 0)
		end
			
		o.oTimer = 0
	end
end

function truck_init(o) --STARTS AT X-4000 AND DELETES AT X+4300
	local m = gMarioStates[0]
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	o.oFaceAngleYaw = 16384
	o.oForwardVel = gGlobalSyncTable.TruckVel
	o.oMoveAngleYaw = o.oFaceAngleYaw

	o.hitboxRadius = 300
    o.hitboxHeight = 300
	if mario_is_within_rectangle(o.oPosX - 12400, o.oPosX + 12400, o.oPosZ - 1800, o.oPosZ + 1800) ~= 0 then
		if o.oBehParams ~= 1 then
			local_play(sTruck, m.pos, 1)
		else
			local_play(sR2l_car, m.pos, 1)
		end
	end
end

function truck_loop(o)
	local s = gStateExtras[0]
	local nm = nearest_mario_state_to_object(o)
	local m = gMarioStates[0]

	o.oMoveAnglePitch = 0
	o.oMoveAngleRoll = 0
	
	if o.oBehParams ~= 0 then
		o.oMoveAngleYaw = -16384
	else
		o.oMoveAngleYaw = 16384
	end
	cur_obj_set_face_angle_to_move_angle()
	obj_move_xyz_using_fvel_and_yaw(o)
	cur_obj_update_floor()
	if obj_check_hitbox_overlap(o, m.marioObj) and o.oTimer > 2 and (m.action ~= ACT_RAGDOLL or m.action ~= ACT_GONE or (m.action == ACT_RAGDOLL and m.vel.y < 0)) then
		s.isEliminated = true
		if m.action == ACT_DEATH_ON_STOMACH then return end
		if m.pos.y > m.floorHeight then
			m.vel.x = m.vel.x + sins(o.oMoveAngleYaw) * o.oForwardVel/2
			m.vel.z = m.vel.z + coss(o.oMoveAngleYaw) * o.oForwardVel/2
			m.vel.y = 65
			local angle = obj_angle_to_object(m.marioObj, o)
			m.marioObj.oFaceAngleYaw = angle
			m.marioObj.oMoveAngleYaw = m.marioObj.oFaceAngleYaw
			spawn_mist_particles()
			set_mario_action(m, ACT_RAGDOLL, 0)
			--squishblood(m.marioObj)
			--network_play(sSplatter, m.pos, 1, m.playerIndex)
		else
			if m.action ~= ACT_GONE then
				m.squishTimer = 50
			end
		end

		if o.oBehParams ~= 1 then
			s.gibAngle = 16384
		else
			s.gibAngle = -16384
		end
		s.gibVel = 10
		s.gibYvelmodifier = -10
		if m.action ~= ACT_GONE then
			network_play(sThump, m.pos, 1, m.playerIndex)
			network_play(sRibbit, m.pos, 1, m.playerIndex)
		end
		o.oTimer = 0
	end
	if o.oFloorType == SURFACE_DEATH_PLANE and o.oTimer > 50 then
		obj_mark_for_deletion(o)
	end
end

function waterplane_init(o)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	cur_obj_disable_rendering()
	obj_set_model_extended(o, E_MODEL_WATER_PLANE)
end

function waterplane(o)
	local m = gMarioStates[0]
	o.oPosX = o.oPosX + 24
	if o.oTimer == 2 then
		cur_obj_enable_rendering()
	end
	if o.oTimer > 630 then
		obj_mark_for_deletion(o)
	end
end

function waterplanespawner_init(o)
	spawn_non_sync_object(id_bhvWaterPlane, E_MODEL_NONE, o.oPosX + 4500, o.oPosY - 200, o.oPosZ, function(water)
		water.oFaceAnglePitch = 0
		water.oFaceAngleRoll = 0
		water.oFaceAngleYaw = 0
		cur_obj_disable_rendering()
	end)
	spawn_non_sync_object(id_bhvWaterPlane, E_MODEL_NONE, o.oPosX + 8600, o.oPosY - 200, o.oPosZ, function(water)
		water.oFaceAnglePitch = 0
		water.oFaceAngleRoll = 0
		water.oFaceAngleYaw = 0
		cur_obj_disable_rendering()
	end)
end

function waterplanespawner(o)
	local m = gMarioStates[0]
	--djui_chat_message_create(tostring(o.oTimer))
	if o.oTimer == 1 then
		spawn_non_sync_object(id_bhvWaterPlane, E_MODEL_NONE, o.oPosX - 1000, o.oPosY - 200, o.oPosZ, function(water)
			water.oFaceAnglePitch = 0
			water.oFaceAngleRoll = 0
			water.oFaceAngleYaw = 0
			cur_obj_disable_rendering()
		end)
	end
	if mario_is_within_rectangle(o.oPosX - 212400, o.oPosX + 22400, o.oPosZ - 3000, o.oPosZ + 3800) ~= 0 then
		if o.oTimer == 57 or o.oTimer == 115 or o.oTimer == 172 or o.oTimer == 230 then
			local_play(sRiver, m.pos, 1)
		end
	end
	if o.oTimer == 230 then
		o.oTimer = 0
	end
end

function log_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_LOG
    o.header.gfx.skipInViewCheck = true
	obj_set_model_extended(o, E_MODEL_LOG)
end

function log_loop(o)
	load_object_collision_model()
	o.oVelX = 20
	o.oPosX = o.oPosX + 20
	if o.oTimer > 800 then
		obj_mark_for_deletion(o)
	end
end

function logspawner_loop(o)
	local m = gMarioStates[0]
	--djui_chat_message_create(tostring(o.oTimer))
	if o.oTimer == 1 then
		spawn_non_sync_object(id_bhvLog, E_MODEL_NONE, o.oPosX - 800, o.oPosY - 200, o.oPosZ, function(log)
			log.oFaceAnglePitch = 0
			log.oFaceAngleRoll = 0
			log.oFaceAngleYaw = 0
		end)
	end
	if o.oBehParams == 1 then
		if gGlobalSyncTable.LogSpawnTimer == 25 or o.oTimer > 340 then
			if o.oTimer < 110 then
			else
				o.oTimer = 0
			end
		end
	elseif o.oBehParams == 2 then
		if gGlobalSyncTable.LogSpawnTimer2 == 25 or o.oTimer > 340 then
			if o.oTimer < 110 then
			else
				o.oTimer = 0
			end
		end
	elseif o.oBehParams == 3 then
		if gGlobalSyncTable.LogSpawnTimer3 == 25 or o.oTimer > 340 then
			if o.oTimer < 110 then
			else
				o.oTimer = 0
			end
		end
	end
end

function obstacle_init(o)
	local obstacle = obstaclePool[o.oBehParams]
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = obstacle.col
	obj_set_model_extended(o, obstacle.model)
	o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
	o.oFaceAnglePitch = 0
	o.oFaceAngleYaw = 0
	o.oFaceAngleRoll = 0
end


function load_col_set_rot(o)
	load_object_collision_model()
	o.oFaceAnglePitch = 0
	o.oFaceAngleYaw = 0
	o.oFaceAngleRoll = 0
end

function bhv_static_loop(o)
	o.header.gfx.skipInViewCheck = true
end

function meteor_init(o)
	local s = gStateExtras[0]
	o.collisionData = COL_METEOR
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	o.oCollisionDistance = 10000
	o.oBounciness = 0
	o.oGravity = -10
end

function meteor_loop(o)
	obj_set_model_extended(o, E_MODEL_METEOR)
	local m = gMarioStates[0]
	local random = math.random(1500)
	load_object_collision_model()
	cur_obj_update_floor_height_and_get_floor()
	if o.oPosY >= -750 then
		cur_obj_move_using_fvel_and_gravity()
		cur_obj_move_using_vel()
		cur_obj_update_floor_height_and_get_floor()
		o.oFaceAnglePitch = o.oFaceAnglePitch + random
		o.oFaceAngleRoll = o.oFaceAngleRoll + random
		o.oFaceAngleYaw = o.oFaceAngleYaw + random
		o.oTimer = 0
		approach_vec3f_asymptotic(gLakituState.focus, o.header.gfx.pos, 3,3,3)
		approach_vec3f_asymptotic(gLakituState.curFocus, o.header.gfx.pos, 3,3,3)
	else
		if o.oTimer == 2 then
			spawn_sync_if_main(id_bhvExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, nil, 0)
			cur_obj_shake_screen(SHAKE_POS_LARGE)
			set_camera_shake_from_point(SHAKE_POS_LARGE, m.pos.x, m.pos.y, m.pos.z)
			--spawn_sync_if_main(id_bhvBowserShockWave, E_MODEL_BOWSER_WAVE, o.oPosX, o.oPosY, o.oPosZ, function (wave)
			--	cur_obj_become_intangible()
			--end, 0)

			local dist = dist_between_objects(o, m.marioObj)
			if dist < 1900 then
				set_camera_shake_from_point(SHAKE_POS_LARGE, m.pos.x, m.pos.y, m.pos.z)
				m.faceAngle.y = obj_angle_to_object(m.marioObj, o) - 32768
				m.vel.y = 150 
				mario_set_forward_vel(m, 40)
				spawn_mist_particles()
				play_character_sound(m, CHAR_SOUND_ATTACKED)
				set_mario_action(m, ACT_RAGDOLL, 0)

			else
				--djui_chat_message_create("not within")
			end
		end
		local waterplane = obj_get_first_with_behavior_id(id_bhvStaticObject)
		waterplane.oPosY = waterplane.oPosY - 0.3

		if o.oTimer == 60 then
			network_play(sCoolOff, m.pos, 1, m.playerIndex)
		end

		set_water_level(0, waterplane.oPosY + 10, false)
		--set_environment_region(0, waterplane.oPosY + 10)
		--set_environment_region(1, waterplane.oPosY + 10)
		--set_environment_region(2, waterplane.oPosY + 10)
		--set_environment_region(3, waterplane.oPosY + 10)

	end
end

function bhv_spiketrap_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
    o.hitboxRadius = 100
    o.hitboxHeight = 100
	o.oFaceAnglePitch = 0
	o.oFaceAngleRoll = 0
	o.oFaceAngleYaw = 0
end

function bhv_spiketrap_loop(o)
    local m = gMarioStates[0]

	if obj_check_hitbox_overlap(o, m.marioObj) and o.oAction ~= 2 then
		--djui_chat_message_create("Hitbox!")
		o.oAction = 2
		network_play(sSpikes, m.pos, 1, m.playerIndex)
		spawn_sync_object(id_bhvStaticObject, E_MODEL_SPIKE, o.oPosX, o.oPosY, o.oPosZ, function (spikes)
			spikes.oFaceAnglePitch = 0
			spikes.oFaceAngleRoll = 0
			spikes.oFaceAngleYaw = 0
		end)
		--set_mario_action(m, ACT_IMPALED, 0)
		m.squishTimer = 50
	end


    if o.oAction == 2 and not m.action == ACT_IMPALED then
		--do nothing
    end
end

function obstacle_finish_init(o)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_FINISH
	o.oCollisionDistance = 10000
    o.header.gfx.skipInViewCheck = true
	o.oFaceAnglePitch = 0
	o.oFaceAngleYaw = 0
	o.oFaceAngleRoll = 0
	o.hitboxRadius = 500
    o.hitboxHeight = 500
end

function obstacle_finish_loop(o)
	local m = gMarioStates[0]
	local s = gStateExtras[0]
	load_object_collision_model()
	if obj_check_hitbox_overlap(o, m.marioObj) and not s.isEliminated and not s.isFinished then
		s.isFinished = true
		set_mario_action(m, ACT_GONE, 0)
		play_race_fanfare()
		s.tempScore = s.tempScore + 1000
		-- Add temp score to permanent score and then clear out the temp score.
		s.playerScore = s.playerScore + s.tempScore
		s.tempScore = 0
	end
	o.oFaceAnglePitch = 0
	o.oFaceAngleYaw = 0
	o.oFaceAngleRoll = 0
end

function bhv_custom_spindel(o)
	o.oFaceAngleYaw = 0
	o.oMoveAngleYaw = o.oFaceAngleYaw
end

function saw_init(o)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	o.oFaceAnglePitch = 0
	o.oFaceAngleYaw = 0
	o.oFaceAngleRoll = 0
	o.hitboxRadius = 200
    o.hitboxHeight = 20
	o.oHomeX = o.oPosX
	obj_scale(o, 0.9)
end

function saw_loop(o)
    local m = gMarioStates[0]
	local s = gStateExtras[0]
	if mario_is_within_rectangle(o.oPosX - 12400, o.oPosX + 12400, o.oPosZ - 1730, o.oPosZ + 1730) ~= 0 and o.oTimer % 65 == 0 then
		local_play(sSawmill, m.pos, .8)
	end
	if mario_is_within_rectangle(o.oPosX - 12400, o.oPosX + 12400, o.oPosZ - 1730, o.oPosZ + 1730) ~= 0 and o.oTimer % 105 == 0 then
		local_play(sSawmill2, m.pos, .6)
	end


	--Bloody saw or not?
	if gGlobalSyncTable.saw1bloody == true and o.oBehParams == 1 then
		obj_set_model_extended(o, E_MODEL_BLOOD_SAW)
	elseif gGlobalSyncTable.saw2bloody == true and o.oBehParams == 2 then
		obj_set_model_extended(o, E_MODEL_BLOOD_SAW)
	end

	o.oFaceAngleRoll = o.oFaceAngleRoll + 7500
	if mario_is_within_rectangle(o.oPosX - 700, o.oPosX + 700, o.oPosZ - 60, o.oPosZ + 60) ~= 0 and m.pos.y < 500 and m.action ~= ACT_GONE then
		s.isEliminated = true
		network_play(sSawhit, m.pos, 1, m.playerIndex)
		m.squishTimer = 50
		--network_send_object(o, true)
		network_play(sRibbit, m.pos, 1, m.playerIndex)
		if o.oBehParams == 1 then
			gGlobalSyncTable.saw1bloody = true
		elseif o.oBehParams == 2 then
			gGlobalSyncTable.saw2bloody = true
		end
		
	end
	o.oPosX = o.oHomeX + sins(o.oTimer*768)*3400
end

function green_dorrie_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
    o.oAnimations = gObjectAnimations.dorrie_seg6_anims_0600F638
    o.collisionData = gGlobalObjectCollisionData.dorrie_seg6_collision_0600F644
    obj_init_animation(o, 2)
	obj_scale(o, 1.4)
	--o.oHomeX = 5800
	--o.oHomeY = 80
	--o.oHomeZ = 280
	o.oFaceAngleYaw = 16384
	network_init_object(o, true, nil)
end

function green_dorrie_loop(o)
    cur_obj_init_animation(1)
    o.oAnimState = o.oTimer % 90
    load_object_collision_model()
end

function powerup_speed_pickup_init(o)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	o.oFaceAnglePitch = 16384
	o.oFaceAngleYaw = 0
	o.oFaceAngleRoll = 0
	o.hitboxRadius = 300
    o.hitboxHeight = 20
	o.oPosY = o.oPosY + 200
end

function powerup_speed_pickup_loop(o)
	local m = gMarioStates[0]
	local s = gStateExtras[0]
	o.oFaceAngleYaw = o.oFaceAngleYaw + 1500

	if obj_check_hitbox_overlap(m.marioObj, o) and not s.hasPowerup then
		djui_popup_create_global(tostring(gNetworkPlayers[m.playerIndex].name) .. " got super speed!", 1)
		obj_mark_for_deletion(o)
		s.hasPowerup = true
		s.hasSpeed = true
	else
		--nothing for now. Might play a sound or something to let players know they can't double up on perks.
	end

end

function laser_init(o)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
end

HUNTER_SEARCHING = 0
HUNTER_TARGETING = 1
HUNTER_SHOOTING  = 2
HUNTER_REST      = 3

---@param o Object
function laser_loop(o)
	local i
	local m
	local s

	local pos
	local ray
	local dist
	local scale

	local inCover
	local inRange

	if o.oAction ~= HUNTER_SEARCHING then
		i = o.heldByPlayerIndex
		m = gMarioStates[i]
		s = gStateExtras[i]

		pos = vec3f(m.pos.x, m.pos.y + 100, m.pos.z)
		ray = collision_find_surface_on_ray(o.oPosX, o.oPosY, o.oPosZ, pos.x - o.oPosX, pos.y - o.oPosY, pos.z - o.oPosZ)

		dist = dist_between_object_and_point(o, pos.x, pos.y, pos.z)
		scale = dist
		if ray.surface then
			scale = dist_between_object_and_point(o, ray.hitPos.x, ray.hitPos.y, ray.hitPos.z)
		end

		inCover = scale < dist
		inRange = dist < 6000 and m.pos.z > o.oPosZ + 400
	end

	if o.oAction == HUNTER_SEARCHING then
		local oldDist = 6000
		for j = 0, MAX_PLAYERS-1 do
			m = gMarioStates[j]
			s = gStateExtras[j]
			pos = vec3f(m.pos.x, m.pos.y + 100, m.pos.z)

			ray = collision_find_surface_on_ray(o.oPosX, o.oPosY, o.oPosZ, pos.x - o.oPosX, pos.y - o.oPosY, pos.z - o.oPosZ)

			dist = math.min(vec3f_dist(OBJ_POS(o), ray.hitPos), dist_between_object_and_point(o, pos.x, pos.y, pos.z))
			inRange = dist < 6000 and m.pos.z > o.oPosZ + 400

			local ignored = s.isEliminated

			if not ray.surface and inRange and not ignored and dist < oldDist then
				oldDist = dist
				o.heldByPlayerIndex = j
				o.oAction = HUNTER_TARGETING
			end
		end
	elseif o.oAction == HUNTER_TARGETING then
		obj_rotate_towards_point(o, pos, 0,0,0,0)
		cur_obj_set_face_angle_to_move_angle()
		obj_scale_xyz(o, 1, 1, scale/54)

		if o.oTimer > 30 then
			o.oAction = HUNTER_SHOOTING
			return
		else
			if inCover then
				o.oBehParams = o.oBehParams + 1

				if o.oBehParams > 10 then
					o.oBehParams = 5 -- 5 frames of rest
					o.oAction = HUNTER_REST
				return end
			else o.oBehParams = 0 end
			if dist > 6000 or m.pos.z < o.oPosZ + 400 then
				o.oBehParams = 1 -- forget immediately
				o.oAction = HUNTER_REST
			end
		end
	elseif o.oAction == HUNTER_SHOOTING then
		if o.oTimer == 1 then
			local hunter = obj_get_nearest_object_with_behavior_id(o, id_bhvHunter)
			spawn_non_sync_object(id_bhvMistCircParticleSpawner, E_MODEL_MIST, hunter.oPosX - 10, hunter.oPosY, hunter.oPosZ + 120, nil)
			network_play(sGunshot, OBJ_POS(hunter), 1, i)
			spawn_sync_if_main(id_bhvBulletMiss, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, nil, i)
		elseif o.oTimer == 10 then
			if not inCover then
				s.inCover = false
				network_play(sBulletSplat, m.pos, 1.5, m.playerIndex)
				bloodmist(m.marioObj)
				s.isEliminated = true
				play_character_sound(m, CHAR_SOUND_ATTACKED)
				if m.action == ACT_DEATH_ON_STOMACH then return end
				m.vel.x = m.vel.x + sins(o.oMoveAngleYaw) * 10
				m.vel.z = m.vel.z + coss(o.oMoveAngleYaw) + 140
				m.vel.y = 45
				--perform_air_step(m, 0)
				local angle = obj_angle_to_object(m.marioObj, o)
				m.marioObj.oFaceAngleYaw = angle
				m.marioObj.oMoveAngleYaw = angle
				set_mario_action(m, ACT_RAGDOLL, 0)
				local random = math.random(2)
				if random == 1 then
					local_play(sHunter, m.pos, 1)
				else
					local_play(sHunter2, m.pos, 1)
				end
			else
				s.inCover = true
			end

			o.oBehParams = 5
			o.oAction = HUNTER_REST
		end
	elseif o.oAction == HUNTER_REST then
		if o.oTimer == o.oBehParams then
			o.oAction = HUNTER_SEARCHING
		return end
	end

	if o.oAction == HUNTER_TARGETING then
		cur_obj_enable_rendering()
	else cur_obj_disable_rendering() end
end

function cover_init(o)
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	o.hitboxRadius = 600
    o.hitboxHeight = 200
	o.oCollisionDistance = 4000
end

function bullet_miss(o)
	local m = gMarioStates[0]
	local s = gStateExtras[0]
	if o.oTimer == 12 and s.inCover then
		cur_obj_update_floor_height_and_get_floor()
		--djui_chat_message_create("miss!")

		network_play(sBulletMiss, m.pos, 1, m.playerIndex)
		spawn_sync_if_main(id_bhvDirtParticleSpawner, E_MODEL_DIRT_ANIMATION, o.oPosX, o.oFloorHeight, o.oPosZ, nil, 0)

		--spawn_sync_if_main(id_bhvExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oFloorHeight, o.oPosZ, function(bomb) obj_scale(bomb, 0.02) end, 0)
	end

	if o.oTimer >= 16 then
		obj_mark_for_deletion(o)
	end

end

function hunter_init(o)
	local m = gMarioStates[0]
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
end

function hunter_loop(o)
	local m = gMarioStates[0]
	if m.pos.z > o.oPosZ + 400 then
		obj_rotate_towards_point(o, m.pos, -300,0,0,0)
		cur_obj_set_face_angle_to_move_angle()
	else
		o.oFaceAnglePitch = 0
		o.oFaceAngleYaw = 0
		o.oFaceAngleRoll = 0
		o.oMoveAnglePitch = o.oFaceAnglePitch
		o.oMoveAngleYaw = o.oFaceAngleYaw
		o.oMoveAngleRoll = o.oFaceAngleRoll
	end
	
end

function tripped_init(o)
	local m = gMarioStates[0]
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	--obj_set_billboard(o)
	o.oFaceAnglePitch = 8192
	o.oFaceAngleYaw = 0
end

function tripped_loop(o)
	local m = gMarioStates[0]
	o.oPosY = o.oPosY + 16
	obj_scale(o, 1 - (o.oTimer*0.025))
	if o.oTimer > 30 then
		obj_mark_for_deletion(o)
	end
end

function radio_init(o)
	local m = gMarioStates[0]
	o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
	o.hitboxHeight = 250
	o.hitboxRadius = 250
end

function radio_loop(o)
	local m = gMarioStates[0]
	local volume = 0
	if obj_check_hitbox_overlap(o, m.marioObj) and m.action == ACT_PUNCHING and o.oAction ~= 2 then
		stream_stop_all()
		play_secondary_music(0,0,0,0)
		local oPos = {
			x = o.oPosX,
			y = o.oPosY,
			z = o.oPosZ
		}
		set_mario_action(m, ACT_TRIPLE_JUMP_LAND, 0)
		local random = math.random(2)
		if random == 1 then
			local_play(sBoombox, oPos, 1)
		else
			local_play(sBoombox2, oPos, 1)
		end
		o.oTimer = 0
		o.oAction = 2
	end

	if o.oAction == 2 then
		--boombox jumping around animation like it's blasting music.
	end

	stream_set_volume(clampf(lateral_dist_between_objects(o, m.marioObj)/800, 0.4, 1))
end

-------Behavior Hooks-------
hook_behavior(id_bhvSpindel, OBJ_LIST_SURFACE, false, nil, bhv_custom_spindel)
hook_behavior(id_bhvStaticObject, OBJ_LIST_GENACTOR, false, nil, bhv_static_loop)
hook_behavior(id_bhvSquishablePlatform, OBJ_LIST_SURFACE, false, nil, bhv_squishable_platform_loop)
hook_behavior(id_bhvThwomp, OBJ_LIST_SURFACE, false, nil, bhv_custom_thwomp)
hook_behavior(id_bhvThwomp2, OBJ_LIST_SURFACE, false, nil, bhv_custom_thwomp)
hook_behavior(id_bhvExplosion, OBJ_LIST_DESTRUCTIVE, false, bhv_custom_explosion, nil)
hook_behavior(id_bhvPushableMetalBox, OBJ_LIST_SURFACE, false, cover_init, nil)

id_bhvSquishblood = hook_behavior(nil, OBJ_LIST_GENACTOR, true, squishblood_init, squishblood_loop, "bhvSquishblood")
id_bhvBloodMist = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, true, blood_mist_init, blood_mist_loop, "bhvBloodMist")
id_bhvGib = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, true, gib_init, gib_loop, "bhvGib")
id_bhvTruck = hook_behavior(nil, OBJ_LIST_GENACTOR, true, truck_init, truck_loop, "bhvTruck")
id_bhvl2rTruckSpawner = hook_behavior(nil, OBJ_LIST_GENACTOR, true, nil, l2r_truck_spawner, "bhvl2rTruckSpawner")
id_bhvr2lTruckSpawner = hook_behavior(nil, OBJ_LIST_GENACTOR, true, nil, r2l_truck_spawner, "bhvr2lTruckSpawner")
id_bhvWaterPlane = hook_behavior(nil, OBJ_LIST_SURFACE, true, waterplane_init, waterplane, "bhvWaterPlane")
id_bhvWaterPlaneSpawner = hook_behavior(nil, OBJ_LIST_GENACTOR, true, waterplanespawner_init, waterplanespawner, "bhvWaterPlaneSpawner")
id_bhvLog = hook_behavior(nil, OBJ_LIST_SURFACE, true, log_init, log_loop, "bhvLog")
id_bhvLogSpawner = hook_behavior(nil, OBJ_LIST_SURFACE, true, nil, logspawner_loop, "bhvLogSpawner")
id_bhvObstacle = hook_behavior(nil, OBJ_LIST_SURFACE, true, obstacle_init, load_col_set_rot, "bhvObstacle")
id_bhvMeteor = hook_behavior(nil, OBJ_LIST_SURFACE, true, meteor_init, meteor_loop, "bhvMeteor")
id_bhvSpikes = hook_behavior(nil, OBJ_LIST_GENACTOR, true, bhv_spiketrap_init, bhv_spiketrap_loop, "bhvSpikes")
id_bhvObstacleFinish = hook_behavior(nil, OBJ_LIST_SURFACE, true, obstacle_finish_init, obstacle_finish_loop, "bhvObstacleFinish")
id_bhvSaw = hook_behavior(nil, OBJ_LIST_GENACTOR, true, saw_init, saw_loop, "bhvSaw")
id_bhvGreenDorrie = hook_behavior(nil, OBJ_LIST_SURFACE, true, green_dorrie_init, green_dorrie_loop, "bhvGreenDorrie")
id_bhvSpeedPowerUp = hook_behavior(nil, OBJ_LIST_GENACTOR, true, powerup_speed_pickup_init, powerup_speed_pickup_loop, "bhvSpeedPowerUp")
id_bhvLaser = hook_behavior(nil, OBJ_LIST_GENACTOR, true, laser_init, laser_loop, "bhvLaser")
id_bhvBulletMiss = hook_behavior(nil, OBJ_LIST_GENACTOR, true, nil, bullet_miss, "bhvBulletMiss")
id_bhvHunter = hook_behavior(nil, OBJ_LIST_GENACTOR, true, hunter_init, hunter_loop, "bhvHunter")
id_bhvTripped = hook_behavior(nil, OBJ_LIST_GENACTOR, true, tripped_init, tripped_loop, "bhvTripped")
id_bhvBoombox = hook_behavior(nil, OBJ_LIST_GENACTOR, true, radio_init, radio_loop, "bhvBoombox")


hook_event(HOOK_UPDATE, spawn_obstacles) -- previously mario-updated
hook_event(HOOK_UPDATE, round_start) -- previously mario-updated
hook_event(HOOK_MARIO_UPDATE, round_reset) -- previously mario-updated
hook_event(HOOK_ON_HUD_RENDER, hud)

local musicPool = {
	choco,
	SEQ_LEVEL_SLIDE,
	--SEQ_MENU_TITLE_SCREEN,
	jumper,
	--bloopin,
	secret
}

hook_event(HOOK_ON_LEVEL_INIT, function ()
	--Stop music when exiting levels
	stream_stop_all()
	stream_set_volume(1)
	stop_all_samples()
	local np = gNetworkPlayers[0]

	if np.currLevelNum == LEVEL_POND then
		gMarioStates[0].health = 0x880

		play_secondary_music(0, 0, 0, 10)
		stream_play(bloopin)
		spawn_non_sync_object(id_bhvStaticObject, E_MODEL_WATER_PLANE, 29, -870, -14, nil)
	end

	if np.currLevelNum == LEVEL_FROGGER then
		set_override_fov(60)
		set_fov_shake(15,0,0)
		
		local music = musicPool[math.random(#musicPool)]
		if type(music) == "number" then
			set_background_music(0, music, 0)
		else
			stream_play(music)
		end
	end
end)


--Disable mario's fire scream to make room for custom scream.
hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
	local s = gStateExtras[m.playerIndex]
	local np = gNetworkPlayers[0]
	if sound == CHAR_SOUND_ON_FIRE then return 0 end

	local o = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvPiranhaPlant)
	if sound == CHAR_SOUND_ATTACKED and obj_check_hitbox_overlap(m.marioObj, o) then return 0 end

	if sound == CHAR_SOUND_DYING and (s.headless or s.bottomless) then return 0 end

	if sound == CHAR_SOUND_WAAAOOOW and m.action == ACT_THROWN_FORWARD or m.action == ACT_THROWN_BACKWARD then return 0 end --and (s.flyingVel > 60)

end)

hook_chat_command("reset", "Reset", function ()
	if network_is_server() then
		allEliminated = true
	end
	return true
end)

hook_chat_command("start", "Start", function ()
	if network_is_server() then
		initiate_countdown = true
		gGlobalSyncTable.timer = 30
		roundStart_prompt = false
	end
	return true
end)
